
package javafxclasses;

import javafx.geometry.Point2D;
import javafx.geometry.Rectangle2D;
import javafx.util.Math;

public class ExampleCircle extends ExampleShape {
    public var centerX:Number;
    public var centerY:Number;
    public var radius:Number on replace {
        if (radius < 0) {
            radius = 0;
        }
    };

    public override bound function getArea():Number {
        Math.PI * radius * radius;
    }

    public override bound function getBounds():Rectangle2D {
        Rectangle2D {
            minX: centerX - radius
            minY: centerY - radius
            width: 2 * radius
            height: 2 * radius
        }
    }

    public override bound function contains(point:Point2D):Boolean {
        return (point.x - centerX) * (point.x - centerX)
                + (point.y - centerY) * (point.y - centerY)
                < radius * radius;
    }

    public override function toString():String {
        "Circle at ({centerX}, {centerY}), radius: {radius}"
        ", {super.toString()}"
    }
}
