package javafxclasses;

import java.lang.Cloneable;
import javafx.geometry.Point2D;
import javafx.geometry.Rectangle2D;

public class ExampleRectangle extends ExampleShape, Cloneable {
    public var x:Number;
    public var y:Number;
    public var width:Number;
    public var height:Number;

    public override bound function getArea():Number {
        width * height;
    }

    public override bound function getBounds():Rectangle2D {
        Rectangle2D {
            minX: x
            minY: y
            width: width
            height: height
        }
    }

    public override bound function contains(point:Point2D):Boolean {
        return point.x >= x and point.x < x + width
        and point.y >= y and point.y < y + height;
    }

    public bound function contains(rect:ExampleRectangle):Boolean {
        var topLeft = Point2D { 
            x: rect.x
            y: rect.y };
        var bottomRight = Point2D { 
            x: rect.x + rect.width - 1
            y: rect.y + rect.height - 1
                          };
        return contains(topLeft) and contains(bottomRight);
    }

    public override function toString():String {
        "Rectangle at ({x}, {y}), width: {width}, height: {height}"
        ", {super.toString()}"
    }

    public override function clone():ExampleRectangle {
        return ExampleRectangle {
            x: x
            y: y
            width: width
            height: height
        };
    }
}
