package javafxclasses;

import java.lang.Throwable;
import java.util.logging.Level;
import java.util.logging.Logger;

public mixin class Logging {
    protected var loggerName = getPackageName();
    protected var logger = Logger.getLogger(loggerName);
    public var level = Level.INFO;

    public function isLogging():Boolean {
        level != Level.OFF;
    }

    protected function log(level:Level, text:String) {
        logger.log(level, text);
    }
    
    protected function log(level:Level, text:String, t:Throwable) {
        logger.log(level, text, t);
    }
    
    protected function log(text:String) {
        logger.log(level, text);
    }
    
    protected function log(text:String, t:Throwable) {
        logger.log(level, text, t);
    }

    public override function toString():String {
        "Logging mixin, log level is {level}"
    }

    function getPackageName():String {
        var className = getClass().getName();
        var index = className.lastIndexOf(".");
        return if (index == -1) "default"
               else className.substring(0, index);
    }
}
