package javafxcustom;

import javafx.animation.Timeline;
import javafx.scene.paint.Color;
import javafx.scene.paint.RadialGradient;
import javafx.scene.paint.Stop;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

var stylesheet:String = "{__DIR__}coords1.css" on replace { println(stylesheet) };
var scene:Scene;
Stage {
    title : "CoordinateGrid #1"
    scene: scene = Scene {
        width: 200
        height: 200
        stylesheets: bind [
            stylesheet
        ]
        content: [
            CoordinateGrid2 {
                width: bind scene.width
                height: bind scene.height
            }
            Circle {
                centerX: bind scene.width / 2
                centerY: bind scene.height /2
                radius: bind scene.width / 3
                fill: RadialGradient {
                    centerX: 0.5 centerY: 0.5
                    radius: 1.0 proportional: true
                    stops: [
                        Stop { offset: 0 color: Color.WHITE }
                        Stop { offset: 1 color: Color.GREEN }
                    ]
                }
            }
        ]
    }
}

var t = Timeline {
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        at (0s) { stylesheet => "{__DIR__}coords1.css" }
        at (3s) { stylesheet => "{__DIR__}coords2.css" }
        at (6s) { stylesheet => "{__DIR__}coords1.css" }
    ]
}
t.play();


