package javafxcustom;

import javafx.scene.CustomNode;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafx.scene.shape.Line;
import javafx.scene.shape.Rectangle;

public class CoordinateGrid2 extends CustomNode {
    public var fill:Paint = Color.WHITE;
    public var gridLineColor:Paint = Color.LIGHTGRAY;
    public var gridDistance:Number = 10;
    public var width:Number;
    public var height:Number;

    protected override function create():Node {
        return Group {
            content: bind [
                Rectangle {
                    x: 0
                    y: 0
                    fill: fill
                    width: width
                    height: height
                },
                for (column in [0..width/gridDistance]) {
                    Line {
                        startX: column * gridDistance
                        startY: 0
                        endX: column * gridDistance
                        endY: height - 1
                        stroke: gridLineColor
                    }
                }
                for (row in [0..height/gridDistance]) {
                    Line {
                        startX: 0
                        startY: row * gridDistance
                        endX: width - 1
                        endY: row * gridDistance
                        stroke: gridLineColor
                    }
                }
            ]
        }
    }
}