package javafxdata;

import javafx.async.JavaTaskBase;
import javafx.data.Pair;
import java.util.Properties;

import javafx.async.RunnableFuture;

public class FetchCustomersTask extends JavaTaskBase, TaskUpdater {
    public-init var dbURL:String;
    public-init var params:Pair[];
    public-read var customers:JavaFXCustomer[];
    public var onCustomers:function(JavaFXCustomer[]):Void;

    protected override function create():RunnableFuture {
        var props = new Properties();
        for (param in params) {
            props.put(param.name, param.value);
        }
        new JavaCustomerFetcher(dbURL, props, this);
    }

    // Implementation of TaskUpdater interface
    public override function setReturnValue(value:Object) {
        var javaCustomers = value as nativearray of JavaCustomer;
        for (javaCustomer in javaCustomers) {
            insert JavaFXCustomer {
                customerId: javaCustomer.customerId;
                name: javaCustomer.name;
            } into customers;
        }
        if (onCustomers != null) {
            onCustomers(customers);
        }
    }

    public override function setProgress(progress:Long,
                                         maxProgress:Long) {
        this.progress = progress;
        this.maxProgress = maxProgress;
    }
}

