package javafxdata;

import javafx.io.http.HttpRequest;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.Scene;
import javafx.stage.Stage;
import javax.imageio.ImageIO;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import javafx.ext.swing.SwingUtils;

var image:Image;
var r:HttpRequest = HttpRequest {
    location: "https://duke.dev.java.net/images/rover/OnBridge11small.jpg"
    sink: new ByteArrayOutputStream()
    onDoneRead: function() {
        var os = r.sink as ByteArrayOutputStream;
        var is = new ByteArrayInputStream(os.toByteArray());
        var bimg = ImageIO.read(is);
        is.close();
        os.close();
        image = SwingUtils.toFXImage(bimg);
    }
};
r.start();

Stage {
    var scene:Scene;
    title : "HttpRequest Example #1"
    scene: scene = Scene {
        width: 350
        height: 280
        content: [
            ImageView {
                image: bind image
                x: bind (scene.width - image.width)/2
                y: bind (scene.height - image.height)/2
            }
        ]
    }
}
