package javafxdata;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.VBox;
import javafx.scene.layout.HBox;
import javafx.scene.text.Text;
import javafx.scene.control.TextBox;
import javafx.scene.text.Font;
import javafx.scene.paint.Color;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.layout.LayoutInfo;
import javafx.scene.layout.Priority;

var weather = "Enter ICAO code and press ENTER";
var fetchingWeather = false;
Stage {
    title : "JSON Weather Service"
    var scene:Scene;
    scene: scene = Scene {
        width: 400
        height: 200
        fill: LinearGradient {
            startX: 0.0 endX: 0.0
            startY: 0.0 endY: 1.0
            stops: [
                Stop { offset: 0.0 color: Color.DARKBLUE }
                Stop { offset: 1.0 color: Color.LIGHTBLUE }
            ]
        }
        content: [
            VBox {
                width: bind scene.width
                height: bind scene.height
                spacing: 16
                content: [
                    HBox {
                        spacing: 4
                        var textBox:TextBox;
                        content: [
                            Text {
                                content: "ICAO Code: "
                                fill: Color.rgb(188, 194, 252)
                                font: Font { name: "Arial Bold" size: 16 }
                            }
                            textBox = TextBox {
                                columns: 4
                                disable: bind fetchingWeather
                                action: function() {
                                    getWeather(textBox.text.toUpperCase());
                                }
                                layoutInfo: LayoutInfo {
                                    hfill: false
                                }
                            }
                        ]
                        layoutInfo: LayoutInfo {
                            vgrow: Priority.NEVER
                        }
                    }
                    Text {
                        wrappingWidth: bind scene.width
                        font: Font { name: "Arial Bold" size: 16 }
                        fill: Color.WHITE
                        content: bind weather;
                    }
                ]
            }
        ]
    }
}

function getWeather(place:String) {
    fetchingWeather = true;
    JSONWeatherClient.getWeather(place,
        function(result:String):Void {
            weather = result;
            fetchingWeather = false;
        }
    );
}

