package javafxdata;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.paint.Color;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.layout.LayoutInfo;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.scene.control.TextBox;
import javafx.scene.layout.Priority;
import javafx.geometry.HPos;

var weather:RSSWeatherFeedClient.RSSWeather;
var fetchingWeather:Boolean;
var weatherNode:InformationNode;
var holder:VBox;
Stage {
    title: "RSS Weather Feed"
    width: 380
    height: 250
    var scene:Scene;
    scene: scene = Scene {
        fill: LinearGradient {
            startX: 0.0 endX: 0.0
            startY: 0.0 endY: 1.0
            stops: [
                Stop { offset: 0.0 color: Color.DARKBLUE }
                Stop { offset: 1.0 color: Color.LIGHTBLUE }
            ]
        }
        content: [
            holder = VBox {
                width: bind scene.width
                height: bind scene.height
                spacing: 8
                nodeHPos: HPos.CENTER
                content: [
                    Text {
                        content: "Yahoo! RSS Weather Feed"
                        fill: Color.WHITE
                        font: Font {
                                  name: "Arial Bold"
                                  size: 14
                              }
                    }
                    HBox {
                        spacing: 8
                        var textBox:TextBox;
                        content: [
                            Text {
                                content: "Location Code: "
                                fill: Color.rgb(188, 194, 252)
                                font: Font { name: "Arial Bold" size: 16 }
                            }
                            textBox = TextBox {
                                columns: 8
                                disable: bind fetchingWeather
                                action: function() {
                                    getWeather(textBox.text);
                                }
                            }
                        ]
                        layoutInfo: LayoutInfo {
                            hfill: false
                            vgrow: Priority.NEVER
                        }
                    }
                ]
            }
        ]
    }
}

function getWeather(place:String):Void {
    fetchingWeather = true;
    RSSWeatherFeedClient.getRSSWeather(place,
            function(result:RSSWeatherFeedClient.RSSWeather):Void {
        weather = result;
        delete weatherNode from holder.content;
        weatherNode = InformationNode {
            name: weather.title
            message: "{weather.conditions} {weather.temp}\n"
                     "{weather.wind}\n"
                     "{weather.forecast}"
            imageURL: weather.imageURL
        };
        insert weatherNode into holder.content;
        fetchingWeather = false;
    });
}

