package javafxdata;

import javafx.data.feed.rss.RssTask;

import javafx.data.Pair;
import javafx.io.http.URLConverter;
import javafx.data.pull.PullParser;

public class RSSWeather {
    public-read var title:String;
    public-read var conditions:String;
    public-read var temp:String;
    public-read var wind:String;
    public-read var forecast:String;
    public-read var imageURL:String;
}

var task:RssTask;
public function getRSSWeather(place:String, onDone:function(RSSWeather)) {
    var weather = RSSWeather {};
    var params = Pair {
        name: "p" value: "{place}"
    };
    var converter = URLConverter {};
    var urlParams = converter.encodeParameters(params);

    if (task != null) {
        task.stop();
    }

    task = RssTask {
        location: "http://weather.yahooapis.com/forecastrss?{urlParams}"
        interval: 60s
        onItem: function(item) {
            weather.title = item.title;
            var description = item.description;
            var index = description.indexOf("img src=");
            if (index != -1) {
                var startIndex = index + 9;
                var endIndex = description.indexOf('"', startIndex);
                weather.imageURL = description.substring(startIndex, endIndex);
            }
        }
        onForeignEvent: function(evt) {
            if (evt.type == PullParser.START_ELEMENT) {
                var name = evt.qname.name;
                if (name == "wind") {
                    var speed = evt.getAttributeValue("speed");
                    var direction = evt.getAttributeValue("direction");
                    weather.wind = "Wind: {speed} mph from {direction}";
                } else if (name == "condition") {
                    var condition = evt.getAttributeValue("text");
                    var temp = evt.getAttributeValue("temp");
                    weather.conditions = condition;
                    weather.temp = "{temp}F";
                } else if (name == "forecast") {
                    var day = evt.getAttributeValue("day");
                    var date = evt.getAttributeValue("date");
                    var high = evt.getAttributeValue("high");
                    var low = evt.getAttributeValue("low");
                    var text = evt.getAttributeValue("text");
                    weather.forecast = "Forecast for {day} "
                                       "{date} - {text}, high {high}F, "
                                       "low {low}F";
                }
            }
        }
        onDone: function() {
            onDone(weather);
        }
    }
    task.start();
}
