package javafxdata;

import javafx.io.http.HttpRequest;
import javafx.scene.Scene;
import javafx.stage.Stage;
import java.io.ByteArrayOutputStream;
import javafx.scene.layout.VBox;
import javafx.geometry.HPos;
import javafx.geometry.VPos;
import javafx.scene.text.Text;
import javafx.scene.control.Button;
import javafx.scene.control.ProgressBar;

var r:HttpRequest = HttpRequest {
    location: "http://java.sun.com/docs/books/jls/download/langspec-3.0.pdf";
    sink: new ByteArrayOutputStream()
};

Stage {
    var scene:Scene;
    title : "Task Example #1"
    scene: scene = Scene {
        width: 350
        height: 160
        content: [
            VBox {
                width: bind scene.width
                height: bind scene.height
                spacing: 16 vpos: VPos.CENTER
                hpos: HPos.CENTER nodeHPos: HPos.CENTER
                content: [
                    Text {
                        content: bind "Read {r.progress} of {r.maxProgress} "
                                      "({100 * r.percentDone}%)"
                    }
                    ProgressBar {
                        progress: bind if (r.percentDone == -1) 0
                                       else r.percentDone;
                    }
                    Text {
                        wrappingWidth: bind scene.width
                        content: bind if (r.stopped) "Stopped"
                                      else if (r.succeeded) "Complete"
                                      else r.causeOfFailure.toString()
                    }
                    Button {
                        text: "Press to start..."
                        disable: bind r.started
                        action: function() {
                            r.start();
                        }
                    }
                    Button {
                        text: "Press to stop..."
                        disable: bind not r.started or r.done
                        action: function() {
                            r.stop();
                        }
                    }
                ]
            }
        ]
    }
}

var started = bind r.started on replace { println("started: {started}") };
var stopped = bind r.stopped on replace { println("stopped: {stopped}") };
var succeeded = bind r.succeeded on replace { println("succeeded: {succeeded}") };
var failed = bind r.failed on replace { println("failed: {failed}") };
var done = bind r.done on replace { println("done: {done}") };
var causeOfFailure = bind r.causeOfFailure on replace { println("causeOfFailure: {causeOfFailure}"); };
