package javafxdata;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.VBox;
import javafx.geometry.HPos;
import javafx.geometry.VPos;
import javafx.scene.control.Button;
import javafx.scene.control.ListView;
import javafx.scene.text.Text;
import javafx.scene.layout.LayoutInfo;
import javafx.data.Pair;
import javafx.scene.text.TextAlignment;
import javafx.geometry.Insets;
import javafx.scene.layout.Priority;

Stage {
    title: "Task Example #2"
    width: 250
    height: 300
    var scene:Scene;
    scene: scene = Scene {
        content: [
            VBox {
                width: bind scene.width
                height: bind scene.height
                padding: Insets {
                    top: 8 left:8 bottom: 8 right: 8
                }
                vpos: VPos.CENTER
                nodeHPos: HPos.CENTER
                spacing: 8
                content: [
                    ListView {
                        items: bind for (c in customers) {
                            c.name
                        }
                        layoutInfo: LayoutInfo {
                            hfill: true
                            vfill: true
                            hgrow: Priority.ALWAYS
                            vgrow: Priority.ALWAYS
                        }
                    }
                    Text {
                        textAlignment: TextAlignment.CENTER
                        content: bind "Progress: {(100 * task.percentDone) as Integer}\n"
                                      "{if (task.causeOfFailure == null)
                                        "" else task.causeOfFailure}"
                    }
                    Button {
                        text: "Fetch Customers"
                        disable: bind task.started;
                        action: function() {
                            getCustomers();
                        }
                    }
                ]
            }
        ]
    }
}

var customers:JavaFXCustomer[];
var task:FetchCustomersTask;

function getCustomers() {
    task = FetchCustomersTask {
        dbURL: "jdbc:derby://localhost:1527/sample"
        params: [
            Pair { name: "user" value: "app" },
            Pair { name: "password" value: "app" }
        ]
        onCustomers: function(result):Void {
            customers = result;
        }
    }
    task.start();
}
