package javafxdata;

import javafx.data.feed.atom.AtomTask;
import javafx.data.Pair;
import javafx.io.http.URLConverter;

import java.util.Date;

public function doTwitterAtomSearch(query:String, count:Integer,
                                    onDone:function(TwitterEntry[]):Void) {
    var params = [
        Pair { name: "q" value: query },
        Pair { name: "rpp" value: "{count}" }
    ];
    var converter = URLConverter {};
    var urlParams = converter.encodeParameters(params);

    var task = AtomTask {
        location: "http://search.twitter.com/search.atom?{urlParams}"
        var entries:TwitterEntry[];
        onEntry: function(entry) {
            var user = entry.authors[0].name;
            var content = entry.title.text;
            var time = new Date(entry.published.datetime.instant).toString();
            var imageURL = "";
            for (link in entry.links) {
                if (link.rel == "image") {
                    imageURL = link.href;
                    break;
                }
            }
            insert TwitterEntry {
                user: user
                content: content
                time: time
                imageURL: imageURL
            } into entries;
        }
        onDone: function() {
            onDone(entries);
        }
    }
    task.update();
}
