package javafxdata;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.ScrollBar;
import javafx.geometry.HPos;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.paint.Color;
import javafx.scene.layout.HBox;
import javafx.scene.layout.ClipView;
import javafx.scene.layout.VBox;
import javafxdata.TwitterEntry;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.geometry.Insets;
import javafx.scene.layout.LayoutInfo;
import javafx.scene.layout.Priority;

var entries:TwitterEntry[];
Stage {
    title: "Twitter InformIT Timeline"
    width: 380
    height: 450
    var scene:Scene;
    scene: scene = Scene {
        fill: LinearGradient {
            startX: 0.0 endX: 0.0
            startY: 0.0 endY: 1.0
            stops: [
                Stop { offset: 0.0 color: Color.DARKBLUE }
                Stop { offset: 1.0 color: Color.LIGHTBLUE }
            ]
        }
        content: [
            VBox {
                width: bind scene.width
                height: bind scene.height
                padding: Insets {
                    top: 3 left: 3 bottom: 3 right: 3
                }
                spacing: 3
                nodeHPos: HPos.CENTER
                content: [
                    Text {
                        content: "Twitter InformIT Timeline"
                        fill: Color.WHITE
                        font: Font { name: "Arial Bold" size: 14 }
                    }
                    HBox {
                        var clipView:ClipView;
                        layoutInfo: LayoutInfo {
                            vfill: true
                            vgrow: Priority.ALWAYS
                        }
                        content: [
                            clipView = ClipView {
                                node: VBox {
                                    nodeHPos: HPos.CENTER
                                    content: bind for (entry in entries) {
                                        InformationNode {
                                            name: entry.user
                                            imageURL: entry.imageURL
                                            message: "{entry.time}\n{entry.content}"
                                        }
                                    }
                                }
                                pannable: false
                                layoutInfo: LayoutInfo {
                                    vfill: true
                                    hfill: true
                                    hshrink: Priority.ALWAYS
                                    hgrow: Priority.ALWAYS
                                    vgrow: Priority.ALWAYS
                                }
                            }
                            ScrollBar {
                                vertical: true
                                max: bind clipView.maxClipY
                                blockIncrement: 64
                                override var value on replace {
                                    clipView.clipY = value
                                }
                                layoutInfo: LayoutInfo {
                                    vfill: true
                                    hgrow: Priority.NEVER
                                    vshrink: Priority.ALWAYS
                                    vgrow: Priority.ALWAYS
                                }
                            }
                        ]
                    }
                ]
            }
        ]
    }
}

TwitterClient.getInformITTimeline(
     function(results:TwitterEntry[]):Void {
         insert results into entries;
     }
);
