
package javafxeffects;

import javafx.ext.swing.SwingComboBox;
import javafx.ext.swing.SwingComboBoxItem;
import javafx.scene.effect.BlendMode;
import javafx.scene.Group;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;



var image1 = Image { url: "{__DIR__}image1.jpg" };
var image2 = Image { url: "{__DIR__}image2.jpg" };
var scene: Scene;
Stage {
    title: "Blend Group"
    scene: scene = Scene {
            var modeCombo: SwingComboBox;
            var mode = bind modeCombo.selectedItem.value as BlendMode;
            width: 500
            height: 400
            fill: Color.BLACK
            content: [
                modeCombo = SwingComboBox {
                    translateX: bind (scene.width - modeCombo.layoutBounds.width) / 2
                    editable: false
                    items: [
                        SwingComboBoxItem {
                            value: BlendMode.ADD
                            text: "ADD"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.BLUE
                            text: "BLUE"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.COLOR_BURN
                            text: "COLOR_BURN"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.COLOR_DODGE
                            text: "COLOR_DODGE"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.DARKEN
                            text: "DARKEN"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.DIFFERENCE
                            text: "DIFFERENCE"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.EXCLUSION
                            text: "EXCLUSION"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.GREEN
                            text: "GREEN"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.HARD_LIGHT
                            text: "HARD_LIGHT"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.LIGHTEN
                            text: "LIGHTEN"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.MULTIPLY
                            text: "MULTIPLY"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.OVERLAY
                            text: "OVERLAY"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.RED
                            text: "RED"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.SCREEN
                            text: "SCREEN"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.SOFT_LIGHT
                            text: "SOFT_LIGHT"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.SRC_ATOP
                            text: "SRC_ATOP"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.SRC_IN
                            text: "SRC_IN"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.SRC_OUT
                            text: "SRC_OUT"
                        }
                        SwingComboBoxItem {
                            value: BlendMode.SRC_OVER
                            text: "SRC_OVER"
                        }
                    ]
                    selectedIndex: 0
                }
                Circle {
                    centerX: 100
                    centerY: 100
                    radius: 80
                    fill: Color.YELLOW
                }
                Group {
                    blendMode: bind if (mode != null) mode else BlendMode.ADD
                    content: [
                        ImageView {
                            x: 30
                            y: 30
                            image: image1
                        }
                        ImageView {
                            x: 150
                            y: 150
                            image: image2
                        }
                    ]
                }
            ]
        }
}