package javafxeffects;

import javafx.ext.swing.SwingSlider;
import javafx.scene.effect.DisplacementMap;
import javafx.scene.effect.FloatMap;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.stage.Stage;

var image: Image = Image { url: "{__DIR__}image1.jpg" };
var imgWidth = image.width as Integer;
var imgHeight = image.height as Integer;
var map: FloatMap = FloatMap {
    width: imgWidth
    height: imgHeight
}

for (i in [0..<map.width]) {
    for (j in [0..<map.height]) {
        map.setSample(i, j, 0, -0.50);
        map.setSample(i, j, 1, -0.50);
    }
}

var scene: Scene;
Stage {
    title: "DisplacementMap #2"
    scene: scene = Scene {
            width: 500
            height: 380
            fill: Color.BLACK
            content: [
                ImageView {
                    translateX: bind (scene.width - imgWidth) / 2
                    translateY: bind (scene.height - 30 - imgHeight) / 2
                    image: image
                    effect: DisplacementMap {
                        mapData: map
                        wrap: true
                    }
                }
            ]
        }
}
