package javafxeffects;

import javafx.ext.swing.SwingLabel;
import javafx.ext.swing.SwingSlider;
import javafx.scene.effect.DisplacementMap;
import javafx.scene.effect.FloatMap;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.stage.Stage;

var image: Image = Image { url: "{__DIR__}image1.jpg"
};
var imgWidth = image.width as Integer;
var imgHeight = image.height as Integer;
var map: FloatMap = FloatMap {
    width: imgWidth
    height: imgHeight
}

for (i in [0..<map.width]) {
    for (j in [0..<map.height]) {
        map.setSample(i, j, 0, -0.50);
        map.setSample(i, j, 1, -0.50);
    }
}

var scene: Scene;
Stage {
    title: "DisplacementMap #3"
    scene:
    scene = Scene {
        width: 500
        height: 390
        fill: Color.BLACK
        var offsetSlider: SwingSlider;
        var scaleSlider: SwingSlider;

        content: [
            ImageView {
                translateX: bind (scene.width - imgWidth) / 2
                translateY: bind (scene.height - 30 - imgHeight) / 2
                image: image
                effect: DisplacementMap {
                    mapData: map
                    offsetX: bind (offsetSlider.value as Number) / 10
                    scaleX: bind (scaleSlider.value as Number) / 10
                }
            }
            SwingLabel {
                text: "offsetX: "
                translateX: 5
                translateY: 350
                foreground: Color.WHITE
            }
            offsetSlider = SwingSlider {
                maximum: 10
                minimum: 0
                value: 0
                translateX: 50
                translateY: 350
                width: bind scene.width - 60
            }
            SwingLabel {
                text: "scaleX: "
                translateX: 5
                translateY: 370
                foreground: Color.WHITE
            }
            scaleSlider = SwingSlider {
                maximum: 20
                minimum: 0
                value: 10
                translateX: 50
                translateY: 370
                width: bind scene.width - 60
            }
        ]
    }
}
