package javafxeffects;

import javafx.ext.swing.SwingLabel;
import javafx.ext.swing.SwingSlider;
import javafx.scene.effect.light.DistantLight;
import javafx.scene.effect.Lighting;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

var scene: Scene;
Stage {
    title: "Distant Light"
    scene:
    scene = Scene {
        width: 400
        height: 390
        fill: Color.BLACK
        var azimuthSlider: SwingSlider;
        var elevationSlider: SwingSlider;

        content: [
            Circle {
                centerX: 200
                centerY: 180
                radius: 150
                fill: Color.YELLOW
                effect: Lighting {
                    light: DistantLight {
                        azimuth: bind azimuthSlider.value
                        elevation: bind elevationSlider.value
                    }
                    surfaceScale: 5
                }
            }
            SwingLabel {
                text: "azimuth: "
                translateX: 5
                translateY: 350
                foreground: Color.WHITE
            }
            azimuthSlider = SwingSlider {
                maximum: 360
                minimum: 0
                value: 45
                translateX: 50
                translateY: 350
                width: bind scene.width - 60
            }
            SwingLabel {
                text: "elevation: "
                translateX: 5
                translateY: 370
                foreground: Color.WHITE
            }
            elevationSlider = SwingSlider {
                maximum: 360
                minimum: 0
                value: 45
                translateX: 50
                translateY: 370
                width: bind scene.width - 60
            }
        ]
    }
}
