
package javafxeffects;

import javafx.ext.swing.SwingLabel;
import javafx.ext.swing.SwingSlider;
import javafx.scene.effect.DropShadow;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

import javafx.scene.effect.BlurType;

Stage {
    title: "Drop Shadow #1"
    resizable: false
    var scene: Scene;
    scene: scene = Scene {
        width: 200 height: 290
        var xSlider: SwingSlider;
        var ySlider: SwingSlider;
        var radiusSlider: SwingSlider;
        var spreadSlider: SwingSlider;
        content: [
            Rectangle {
                x: 30 y: 30
                width: 140 height: 110
                fill: Color.YELLOW
                effect: DropShadow {
                    blurType: BlurType.GAUSSIAN
                    offsetX: bind xSlider.value
                    offsetY: bind ySlider.value
                    radius: bind radiusSlider.value
                    spread: bind (spreadSlider.value as Number)/ 10
                }
            }
            SwingLabel {
                text: "offsetX: "
                translateX: 5 translateY: 200
            }
            xSlider = SwingSlider {
                maximum: 20 minimum: -20
                value: 15
                translateX: 50 translateY: 200
                width: bind scene.width - 60
            }
            SwingLabel {
                text: "offsetY: "
                translateX: 5 translateY: 220
            }
            ySlider = SwingSlider {
                maximum: 20 minimum: -20
                value: 15
                translateX: 50 translateY: 220
                width: bind scene.width - 60
            }
            SwingLabel {
                text: "radius: "
                translateX: 5 translateY: 240
            }
            radiusSlider = SwingSlider {
                maximum: 63 minimum: 0
                value: 10
                translateX: 50 translateY: 240
                width: bind scene.width - 60
            }
            SwingLabel {
                text: "spread: "
                translateX: 5 translateY: 260
            }
            spreadSlider = SwingSlider {
                maximum: 9 minimum: 0
                value: 0
                translateX: 50 translateY: 260
                width: bind scene.width - 60
            }
        ]
    }
}