package javafxeffects;

import java.lang.Math;
import javafx.ext.swing.SwingSlider;
import javafx.scene.effect.PerspectiveTransform;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.stage.Stage;

var scene: Scene;
Stage {
    title: "Perspective Transform #1"
    scene: scene = Scene {
            width: 500
            height: 380
            fill: Color.BLACK
            var image: Image;
            var imgWidth = bind image.width;
            var imgHeight = bind image.height;
            var slider: SwingSlider
            content: [
                ImageView {
                    translateX: bind (scene.width - imgWidth) / 2
                    translateY: bind (scene.height - 30 - imgHeight) / 2
                    image: image = Image { url: "{__DIR__}image1.jpg" }
                    var angle = bind Math.toRadians(slider.value);
                    var pivot = 0.5;
                    var htFactor = 0.2;
                    var l1 = bind pivot * imgWidth;
                    var l2 = bind imgWidth - l1;
                    effect: bind PerspectiveTransform {
                        ulx: l1 - l1 * Math.cos(angle)
                        uly: htFactor * l1 * Math.sin(angle)
                        llx: l1 - l1 * Math.cos(angle)
                        lly: imgHeight - l1 * htFactor * Math.sin(angle)
                        urx: l1 + l2 * Math.cos(angle)
                        ury: -l2 * htFactor * Math.sin(angle)
                        lrx: l1 + l2 * Math.cos(angle)
                        lry: imgHeight + l2 * htFactor * Math.sin(angle)
                    }
                }
                slider = SwingSlider {
                    maximum: 90
                    minimum: -90
                    value: 0
                    translateX: 10
                    translateY: 350
                    width: bind scene.width - 20
                }
            ]
        }
}
