
package javafxeffects;
import javafx.ext.swing.SwingLabel;
import javafx.ext.swing.SwingSlider;
import javafx.scene.effect.light.PointLight;
import javafx.scene.effect.Lighting;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

var scene: Scene;
Stage {
    title: "Point Light #1"
    scene:
    scene = Scene {
        width: 400
        height: 450
        fill: Color.BLACK
        var xSlider: SwingSlider;
        var ySlider: SwingSlider
        var zSlider: SwingSlider;
        var specCSlider: SwingSlider
        var specESlider: SwingSlider
        content: [
            Circle {
                centerX: 200
                centerY: 180
                radius: 150
                fill: Color.YELLOW
                effect: Lighting {
                    light: PointLight {
                        x: bind xSlider.value
                        y: bind ySlider.value
                        z: bind zSlider.value
                    }
                    surfaceScale: 5
                    specularConstant: bind (specCSlider.value as Number) / 10
                    specularExponent: bind specESlider.value
                }
            }
            SwingLabel {
                text: "x: "
                translateX: 5
                translateY: 350
                foreground: Color.WHITE
            }
            xSlider = SwingSlider {
                maximum: 360
                minimum: 0
                value: 45
                translateX: 110
                translateY: 350
                width: bind scene.width - 120
            }
            SwingLabel {
                text: "y: "
                translateX: 5
                translateY: 370
                foreground: Color.WHITE
            }
            ySlider = SwingSlider {
                maximum: 360
                minimum: 0
                value: 45
                translateX: 110
                translateY: 370
                width: bind scene.width - 120
            }
            SwingLabel {
                text: "z: "
                translateX: 5
                translateY: 390
                foreground: Color.WHITE
            }
            zSlider = SwingSlider {
                maximum: 360
                minimum: 0
                value: 45
                translateX: 110
                translateY: 390
                width: bind scene.width - 120
            }
            SwingLabel {
                text: "specularConstant: "
                translateX: 5
                translateY: 410
                foreground: Color.WHITE
            }
            specCSlider = SwingSlider {
                maximum: 20
                minimum: 0
                value: 10
                translateX: 110
                translateY: 410
                width: bind scene.width - 120
            }
            SwingLabel {
                text: "specularExponent: "
                translateX: 5
                translateY: 430
                foreground: Color.WHITE
            }
            specESlider = SwingSlider {
                maximum: 40
                minimum: 0
                value: 20
                translateX: 110
                translateY: 430
                width: bind scene.width - 120
            }
        ]
    }
}
