
package javafxeffects;

import javafx.ext.swing.SwingLabel;
import javafx.ext.swing.SwingSlider;
import javafx.scene.effect.Reflection;
import javafx.scene.paint.Color;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.Scene;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.stage.Stage;

Stage {
    title: "Reflection #1"
    resizable: false
    var scene: Scene;
    scene:
    scene = Scene {
        width: 350
        height: 240
        var fractionSlider: SwingSlider;
        var topOpacitySlider: SwingSlider;
        var bottomOpacitySlider: SwingSlider;
        var topOffsetSlider: SwingSlider;
        fill: LinearGradient {
            startX: 0
            startY: 0
            endX: 0
            endY: 150
            proportional: false
            stops: [
                Stop {
                    color: Color.LIGHTGRAY
                    offset: 0.0
                }
                Stop {
                    color: Color.rgb(0.2, 0.2, 0.2)
                    offset: 0.4
                }
                Stop {
                    color: Color.BLACK
                    offset: 0.9
                }
                Stop {
                    color: Color.WHITE
                    offset: 1.0
                }
            ]
        }

        content: [
            Text {
                content: "JavaFX Developer's Guide"
                x: 20
                y: 50
                fill: Color.WHITE
                font: Font { size: 24
                }
                effect: Reflection {
                    topOffset: bind topOffsetSlider.value as Number
                    fraction: bind (fractionSlider.value as Number) / 10
                    topOpacity: bind (topOpacitySlider.value as Number) / 10
                    bottomOpacity: bind (bottomOpacitySlider.value as Number) / 10
                }
            }
            SwingLabel {
                text: "topOffset: "
                translateX: 5
                translateY: 160
            }
            topOffsetSlider = SwingSlider {
                maximum: 40
                minimum: 0
                value: 0
                translateX: 100
                translateY: 160
                width: bind scene.width - 110
            }
            SwingLabel {
                text: "fraction: "
                translateX: 5
                translateY: 180
            }
            fractionSlider = SwingSlider {
                maximum: 10
                minimum: 0
                value: 5
                translateX: 100
                translateY: 180
                width: bind scene.width - 110
            }
            SwingLabel {
                text: "topOpacity: "
                translateX: 5
                translateY: 200
            }
            topOpacitySlider = SwingSlider {
                maximum: 10
                minimum: 0
                value: 10
                translateX: 100
                translateY: 200
                width: bind scene.width - 110
            }
            SwingLabel {
                text: "bottomOpacity: "
                translateX: 5
                translateY: 220
            }
            bottomOpacitySlider = SwingSlider {
                maximum: 10
                minimum: 0
                value: 0
                translateX: 100
                translateY: 220
                width: bind scene.width - 110
            }
        ]
    }
}
