
package javafxeffects;

import javafx.ext.swing.SwingLabel;
import javafx.ext.swing.SwingSlider;
import javafx.scene.effect.light.SpotLight;
import javafx.scene.effect.Lighting;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

var scene: Scene;
Stage {
    title: "Spot Light #1"
    scene: scene = Scene {
            width: 400
            height: 450
            fill: Color.BLACK
            var xSlider: SwingSlider;
            var ySlider: SwingSlider
            var zSlider: SwingSlider;
            var specESlider: SwingSlider
            content: [
                Circle {
                    centerX: 200
                    centerY: 180
                    radius: 150
                    fill: Color.YELLOW
                    effect: Lighting {
                        light: SpotLight {
                            pointsAtX: bind xSlider.value
                            pointsAtY: bind ySlider.value
                            pointsAtZ: bind zSlider.value
                            x: 200
                            y: 180
                            z: 60
                            specularExponent: bind (specESlider.value as Number)/10
                        }
                        surfaceScale: 5
                    }
                }
                SwingLabel {
                    text: "pointsAtX: "
                    translateX: 5
                    translateY: 350
                    foreground: Color.WHITE
                }
                xSlider = SwingSlider {
                    maximum: 360
                    minimum: 0
                    value: 200
                    translateX: 110
                    translateY: 350
                    width: bind scene.width - 120
                }
                SwingLabel {
                    text: "pointsAtY: "
                    translateX: 5
                    translateY: 370
                    foreground: Color.WHITE
                }
                ySlider = SwingSlider {
                    maximum: 360
                    minimum: 0
                    value: 180
                    translateX: 110
                    translateY: 370
                    width: bind scene.width - 120
                }
                SwingLabel {
                    text: "pointsAtZ: "
                    translateX: 5
                    translateY: 390
                    foreground: Color.WHITE
                }
                zSlider = SwingSlider {
                    maximum: 360
                    minimum: 0
                    value: 45
                    translateX: 110
                    translateY: 390
                    width: bind scene.width - 120
                }
                SwingLabel {
                    text: "specularExponent: "
                    translateX: 5
                    translateY: 410
                    foreground: Color.WHITE
                }
                specESlider = SwingSlider {
                    maximum: 40
                    minimum: 0
                    value: 10
                    translateX: 110
                    translateY: 410
                    width: bind scene.width - 120
                }
            ]
        }
}
