package javafxnodes;

import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javax.swing.JColorChooser;

var fill:Color = Color.WHITESMOKE;
var scene:Scene;

Stage {
    title: "Use JColorChooser"
    resizable: false
    scene:
    scene = Scene {
        width: 200
        height: 200
        fill: bind fill
        content: [
            Group {
                content: [
                    Rectangle {
                        x: 0
                        y:0
                        width: bind scene.width
                        height: bind scene.height
                        fill: Color.TRANSPARENT
                    }
                    Text {
                        x: 35
                        y: 20
                        content: "Click to change color"
                    }
                ]
                onMousePressed: function(evt) {
                    var c:java.awt.Color;
                    c = JColorChooser.showDialog(null, "Select a color", null);
                    if (c != null) {
                        fill = Color.rgb(c.getRed(), c.getGreen(), c.getBlue())
                    }
                }
            }
        ]
    }
}