package javafxreflection;

import javafx.reflect.FXContext;
import javafx.reflect.FXLocal;

var ctx = FXContext.getInstance();
var classType = ctx.findClass("javafxreflection.TestObject");

// Create and set value in two steps.
println("Create and set as two steps");
var objectValue = classType.newInstance();
var valueVarMember = classType.getVariable("value");
valueVarMember.setValue(objectValue, ctx.mirrorOf(20));

// Create and set in one step.
println("Create and set as one step");
objectValue = classType.allocate();
objectValue.initVar("value", ctx.mirrorOf(20));
objectValue.initialize();
var result = (objectValue as FXLocal.ObjectValue).asObject() as TestObject;
println("value is {result.value}");
