package javafxreflection;

import javafx.reflect.FXContext;
import javafx.reflect.FXFunctionMember;
import javafx.reflect.FXMember;
import javafx.reflect.FXMemberFilter;

class FunctionNameFilter extends FXMemberFilter {
    public-init var match:String;

    public override function accept(member:FXMember):Boolean {
        if (not (member instanceof FXFunctionMember)) {
            return false;
        }
        return match == ""
        or member.getName().startsWith(match);
    }
}

var ctx = FXContext.getInstance();
var classType = ctx.findClass("javafxreflection.FunctionsAndVariables");
var filter = FunctionNameFilter { match: "mult" };
var matches = classType.getFunctions(filter, true);
for (matched in matches) {
    println("Matched: {matched.getName()}");
    println("   signature: {matched.getType()}");
}



