package javafxreflection;

import javafx.reflect.FXContext;

var ctx = FXContext.getInstance();
var textBoxClass = ctx.findClass("javafx.scene.control.TextBox");
println(textBoxClass.getName());

var supers = textBoxClass.getSuperClasses(true);
println("Superclasses: ");
for (s in supers) {
    println(s.getName());
}

class MyDate extends java.util.Date {
}

var myDateClass = ctx.findClass("javafxreflection.ReflectClass.MyDate");
supers = myDateClass.getSuperClasses(true);
println("MyDate superclasses: ");
for (s in supers) {
    println(s.getName());
}

println("TextBox isJfxType(): {textBoxClass.isJfxType()}");
var dateClass = ctx.findClass("java.util.Date");
println("Date is isJfxType(): {dateClass.isJfxType()}");

var controlClass = ctx.findClass("javafx.scene.control.Control");
println("{controlClass.isAssignableFrom(textBoxClass)}");
println("{controlClass.isAssignableFrom(myDateClass)}");
