
package javafxreflection;

import javafx.reflect.FXContext;

var ctx = FXContext.getInstance();
var classType = ctx.findClass("javafxreflection.FunctionsAndVariables");

var helloFnMember = classType.getFunction("sayHello");
println("Function name: {helloFnMember.getName()}");
println("   script function? {helloFnMember.isStatic()}");
println("   function type: {helloFnMember.getType()}");

var integerType = ctx.getIntegerType();
var intMultMember = classType.getFunction("multiply", [integerType, integerType]);
println("Function name: {intMultMember.getName()}");
println("   script function? {intMultMember.isStatic()}");
println("   function type: {intMultMember.getType()}");

var numberType = ctx.getNumberType();
var numberMultMember = classType.getFunction("multiply", [numberType, numberType]);
println("Function name: {numberMultMember.getName()}");
println("   script function? {numberMultMember.isStatic()}");
println("   function type: {numberMultMember.getType()}");

var stringType = ctx.getStringType();
var whatMember = classType.getFunction("say", stringType);
println("Function name: {whatMember.getName()}");
println("   script function? {whatMember.isStatic()}");
println("   function type: {whatMember.getType()}");

println("---------------------");
var functions = classType.getFunctions(false);
for (funcMember in functions) {
    println("Function name: {funcMember.getName()}");
    println("   script function? {funcMember.isStatic()}");
    println("   function type: {funcMember.getType()}");
}
