package javafxreflection;

import javafx.reflect.FXContext;

var ctx = FXContext.getInstance();
var classType = ctx.findClass("javafxreflection.FunctionsAndVariables");

var scriptVarMember = classType.getVariable("scriptVar");
println("scriptVar name: {scriptVarMember.getName()}");
println("   script variable? {scriptVarMember.isStatic()}");

var instanceVarMember = classType.getVariable("instanceVar");
println("instanceVar name: {instanceVarMember.getName()}");
println("   script variable? {instanceVarMember.isStatic()}");
println("instanceVar type: {instanceVarMember.getType().getName()}");

println("---------------------");
var variables = classType.getVariables(false);
for (varMember in variables) {
    println("Variable name: {varMember.getName()}");
    println("   script variable? {varMember.isStatic()}");
    println("   variable type: {varMember.getType().getName()}");
}
