package javafxswing;

import javafx.animation.Timeline;
import javafx.ext.swing.SwingComponent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import javafxswing.WrappedProgressBar;
import javax.swing.JProgressBar;

var progressBar = new JProgressBar();
progressBar.setMinimum(0);
progressBar.setMaximum(100);
progressBar.setIndeterminate(false);
progressBar.setStringPainted(true);
progressBar.setValue(0);

Stage {
    title: "Progress Bar Example #1"
    scene: Scene {
        width: 200
        height: 40
        var pb: WrappedProgressBar;
        content: [
            SwingComponent.wrap(progressBar)
        ]
    }
}

var value:Integer on replace {
    progressBar.setValue(value);
    progressBar.setString("{value}% complete");
}

var t = Timeline {
    repeatCount: Timeline.INDEFINITE
    autoReverse: true
    keyFrames: [
        at (10s) { value => 100 }
    ]
};
t.play();
