package javafxswing;

import javafx.animation.Interpolator;
import javafx.animation.Timeline;
import javafx.animation.transition.RotateTransition;
import javafx.ext.swing.SwingLabel;
import javafx.scene.effect.DropShadow;
import javafx.scene.paint.Color;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.Scene;
import javafx.scene.text.Font;
import javafx.stage.Stage;

var label: SwingLabel;
Stage {
    title: "Swing Node #1"
    scene: Scene {
        width: 300
        height: 200
        fill: LinearGradient {
            startX: 0 startY: 0
            endX: 1.0 endY: 0.0
            stops: [
                Stop { offset: 0.0 color: Color.LIGHTGRAY },
                Stop { offset: 1.0 color: Color.BLACK }
            ]
        }

        content: [
            label = SwingLabel {
                text: "A SwingLabel is a Node"
                font: Font { size: 24 }
                foreground: Color.YELLOW
                translateX: 20 translateY: 80
                effect: DropShadow {
                    offsetX: 10 offsetY: 10
                }
            }
        ]
    }
}

var t = RotateTransition {
    node: label
    fromAngle: 0 byAngle: 360
    duration: 2s
    repeatCount: Timeline.INDEFINITE
    interpolator: Interpolator.LINEAR
}
t.play();

