package javafxnodes;

import javafx.scene.control.TextBox;
import javafx.scene.input.KeyEvent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import javafx.scene.control.Button;

function displayKeyEvent(type:String, evt:KeyEvent) {
    print("{type}: char - '{evt.char}', code - '{evt.code}' ");
    println("    text - '{evt.text}'");
    print("    Modifiers:");
    print("{if (evt.altDown) 'ALT ' else ''}");
    print("{if (evt.controlDown) 'CTRL ' else ''}");
    print("{if (evt.metaDown) 'META ' else ''}");
    println("{if (evt.shiftDown) 'SHIFT ' else ''}");
}

Stage {
    title: "Key Events"
    resizable: false
    scene: Scene {
        var textBox:TextBox
        width: 200
        height: 100
        content: [ 
            textBox = TextBox {
                focusTraversable: false
                translateX: 10
                translateY: 20
                columns: 24
                onKeyPressed: function(evt) {
                    displayKeyEvent("Pressed", evt);
                }
                onKeyReleased: function(evt) {
                    displayKeyEvent("Released", evt);
                }
                onKeyTyped: function(evt) {
                    displayKeyEvent("Typed", evt);
                }
            }
            Button {
                translateX: 40
                translateY: 60
                text: bind if (textBox.disabled) {
                              "Enable text input"
                           } else {
                              "Disable text input"
                           }
                action: function() {
                     textBox.disable = not textBox.disable;
                     if (not textBox.disabled) {
                        textBox.requestFocus();
                     }
                }
            }
        ]
    }
}