package javafxnodes;

import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

function displayMouseEvent(type:String, evt:MouseEvent):Void {
    print("{type}. Clicks: {evt.clickCount},"
            " button: {evt.button},"
            " primary: {evt.primaryButtonDown},"
            " middle: {evt.middleButtonDown},"
            " secondary: {evt.secondaryButtonDown}. Keys: ");
        if (evt.altDown) {
            print("ALT ");
        }
        if (evt.controlDown) {
            println("CTRL ");
        }
        if (evt.metaDown) {
            println("META ");
        }
        if (evt.shiftDown) {
            print("SHIFT ")
        }
        println("");
}

Stage {
    title: "Mouse Events 6"
    scene: Scene {
        width: 200
        height: 150
        content: [
            Rectangle {
                x: 10 y: 10
                width: 180 height: 130
                fill: Color.YELLOW stroke: Color.BLACK
                onMousePressed: function(evt) {
                    displayMouseEvent("Pressed", evt);
                }
                onMouseReleased: function(evt) {
                    displayMouseEvent("Released", evt);
                }
                onMouseClicked: function(evt) {
                    displayMouseEvent("Clicked", evt);
                }
            }
        ]
    }
}