package javafxnodes;

import javafx.scene.input.MouseEvent;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

class NodeDragger {
    public-init var node:Node;
    var startX:Number;
    var startY:Number;

    function onMousePressed(evt:MouseEvent):Void {
        startX = evt.node.translateX;
        startY = evt.node.translateY;
    }

    function onMouseDragged(evt:MouseEvent):Void {
        evt.node.translateX = startX + evt.dragX;
        evt.node.translateY = startY + evt.dragY;
    }
    
    postinit {
        node.onMousePressed = onMousePressed;
        node.onMouseDragged = onMouseDragged;
    }
}

var rect:Rectangle;

Stage {
    title: "Mouse Events 8"
    scene: Scene {
        width: 500
        height: 500
        content: [
            rect = Rectangle {
                x: 10 y: 10
                width: 50 height: 50
                fill: Color.YELLOW stroke: Color.BLACK
            }
        ]
    }
}

NodeDragger { node: rect }
