package javafxnodes;

import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.stage.Stage;

import javafx.scene.Group;

Stage {
    title: "Mouse Events 9"
    scene: Scene {
        width: 280
        height: 120
        content: [
            Group {
                onMouseEntered: function(evt) {
                    print("Group enter");
                    println("  node: {evt.node}, "
                            "source: {evt.source}");
                }
                onMouseExited: function(evt) {
                    print("Group exit");
                    println("  node: {evt.node}, "
                            "source: {evt.source}");
                }
                onMouseMoved: function(evt) {
                    print("Group move");
                    println("  node: {evt.node}, "
                            "source: {evt.source}");
                }
                content: [
                    Rectangle {
                        x: 10 y: 10
                        width: 80 height: 80
                        fill: Color.YELLOW stroke: Color.BLACK
                        onMouseEntered: function(evt) {
                            print("Yellow rectangle enter");
                            println("  node: {evt.node}, "
                                    "source: {evt.source}");
                        }
                        onMouseExited: function(evt) {
                            print("Yellow rectangle exit");
                            println("  node: {evt.node}, "
                                    "source: {evt.source}");
                        }
                        onMouseMoved: function(evt) {
                            print("Yellow rectangle move");
                            println("  node: {evt.node}, "
                                    "source: {evt.source}");
                        }
                    }
                    Rectangle {
                        x: 100 y: 10
                        width: 80 height: 80
                        fill: null stroke: Color.RED
                        onMouseEntered: function(evt) {
                            println("No-fill rectangle enter "
                                    "({evt.x}, {evt.y})");
                        }
                        onMouseExited: function(evt) {
                            println("No-fill rectangle exit "
                                    "({evt.x}, {evt.y})");
                        }
                        onMouseMoved: function(evt) {
                            println("No-fill rectangle move "
                                    "({evt.x}, {evt.y})");
                        }
                    }
                    Text {
                        font: Font { size: 24 }
                        x: 200 y: 40
                        content: "Text"
                        onMouseEntered: function(evt) {
                            println("Text enter ({evt.x}, {evt.y})");
                        }
                        onMouseExited: function(evt) {
                            println("Text exit ({evt.x}, {evt.y})");
                        }
                        onMouseMoved: function(evt) {
                            println("Text move ({evt.x}, {evt.y})");
                        }
                        pickOnBounds: false
                    }
                ]
            }
        ]
    }
}