package javafxnodes;

import javafx.scene.Cursor;
import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.scene.ImageCursor;
import javafx.scene.image.Image;

var texts = ["CROSSHAIR", "DEFAULT", "E_RESIZE", "H_RESIZE",
    "HAND", "MOVE", "N_RESIZE", "NE_RESIZE",
    "NW_RESIZE", "S_RESIZE", "SE_RESIZE", "SW_RESIZE",
    "TEXT", "V_RESIZE", "W_RESIZE", "WAIT",
    "NONE", "CUSTOM", "CUSTOM", "CUSTOM"];

var crossHair = ImageCursor {
    image: Image { url: "{__DIR__}Crosshair.png" }
    hotspotX: 16 hotspotY: 16
}

var cursors = [Cursor.CROSSHAIR, Cursor.DEFAULT,
    Cursor.E_RESIZE, Cursor.H_RESIZE,
    Cursor.HAND, Cursor.MOVE,
    Cursor.N_RESIZE, Cursor.NE_RESIZE,
    Cursor.NW_RESIZE, Cursor.S_RESIZE,
    Cursor.SE_RESIZE, Cursor.SW_RESIZE,
    Cursor.TEXT, Cursor.V_RESIZE,
    Cursor.W_RESIZE, Cursor.WAIT,
    Cursor.NONE, crossHair,
    crossHair, crossHair ];

Stage {
    title: "Node Cursors"
    scene: Scene {
        cursor: Cursor.WAIT
        content: [
            for (i in [0..4], j in [0..3]) {
                var index = 4 * i + j;
                Group {
                    var width = 80
                    var height = 32
                    var gap = 4
                    var baseline = 20
                    var text: Text
                    cursor: cursors[index]
                    content: [
                        Rectangle {
                            x: gap + (width + gap) * j
                            y: gap + (height + gap) * i
                            width: width
                            height: height
                            stroke: Color.BLACK
                            fill: Color.TRANSPARENT
                        },
                        text = Text {
                            translateX: bind gap + (width + gap) * j + (width - text.layoutBounds.width) / 2
                            translateY: gap + (height + gap) * i + baseline
                            content: texts[index]
                        }
                    ]
                }
            }
        ]
    }
}
