package javafxshapes;

import javafx.scene.input.MouseEvent;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.shape.CubicCurve;
import javafx.stage.Stage;

var start:Circle;
var end:Circle;
var control1:Circle;
var control2:Circle;

var startX = 20.0 on replace { printValues() };
var startY = 100.0 on replace { printValues() };
var endX = 180.0 on replace { printValues() };
var endY = 100.0 on replace { printValues() };
var controlX1 = 60.0 on replace { printValues() };
var controlY1 = 50.0 on replace { printValues() };
var controlX2 = 120.0 on replace { printValues() };
var controlY2 = 50.0 on replace { printValues() };

function printValues() {
    println("startX: {startX}, startY: {startY}, "
            "endX: {endX}, endY: {endY}, "
            "controlX1: {controlX1}, controlY1: {controlY1}"
            "controlX2: {controlX2}, controlY2: {controlY2}");;
}

class CircleDragger {
    public-init var circle:Circle;
    var startX:Number;
    var startY:Number;

    function onMousePressed(evt:MouseEvent):Void {
        startX = circle.centerX;
        startY = circle.centerY;
    }

    function onMouseDragged(evt:MouseEvent):Void {
        circle.centerX = startX + evt.dragX;
        circle.centerY = startY + evt.dragY;
    }

    postinit {
        circle.onMousePressed = onMousePressed;
        circle.onMouseDragged = onMouseDragged;
    }
}

Stage {
    title: "Cubic Curve"
    scene: Scene {
        width: 200
        height: 200
        content: [
            CubicCurve {
                startX: bind startX
                startY: bind startY
                endX: bind endX
                endY: bind endY
                controlX1: bind controlX1
                controlY1: bind controlY1
                controlX2: bind controlX2
                controlY2: bind controlY2
                fill: null
                stroke: Color.RED
            }
            start = Circle {
                centerX: bind startX with inverse
                centerY: bind startY with inverse
                radius: 3
            }
            end = Circle {
                centerX: bind endX with inverse
                centerY: bind endY with inverse
                radius: 3
            }
            control1 = Circle {
                centerX: bind controlX1 with inverse
                centerY: bind controlY1 with inverse
                radius: 3
            }
            control2 = Circle {
                centerX: bind controlX2 with inverse
                centerY: bind controlY2 with inverse
                radius: 3
            }
        ]
    }
}

CircleDragger { circle: start }
CircleDragger { circle: end }
CircleDragger { circle: control1 }
CircleDragger { circle: control2 }
