package javafxshapes;

import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.ArcTo;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Ellipse;
import javafx.scene.shape.MoveTo;
import javafx.scene.shape.Path;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.stage.Stage;

Stage {
    title: "ArcTo Elements"
    scene: Scene {
        width: 220
        height: 300
        var font = Font { size: 18 }
        content: [
            Ellipse {
                centerX: 40 centerY: 50
                radiusX: 30 radiusY: 20
                fill: null stroke: Color.GRAY
            }
            Ellipse {
                centerX: 70 centerY: 30
                radiusX: 30 radiusY: 20
                fill: null stroke: Color.GRAY
            }
            Circle { centerX: 40 centerY: 30 radius: 3 }
            Circle { centerX: 70 centerY: 50 radius: 3 }
            Text { x: 35 y: 55 content: "A" }
            Text { x: 65 y: 35 content: "B" }

            Path {
                fill: null stroke: Color.BLACK
                elements: [
                    // Arc number 1
                    MoveTo { x: 40 y: 130 }
                    ArcTo  {
                        x: 30 y: 20 absolute: false
                        radiusX: 30 radiusY: 20
                        largeArcFlag: false sweepFlag: false
                    }

                    // Arc number 2
                    MoveTo { x: 140 y: 130 }
                    ArcTo  {
                        x: 30 y: 20 absolute: false
                        radiusX: 30 radiusY: 20
                        largeArcFlag: false sweepFlag: true
                    }

                    // Arc number 3
                    MoveTo { x: 40 y: 230 }
                    ArcTo  {
                        x: 30 y: 20 absolute: false
                        radiusX: 30 radiusY: 20
                        largeArcFlag: true sweepFlag: false
                    }

                    // Arc number 4
                    MoveTo { x: 140 y: 230 }
                    ArcTo  {
                        x: 30 y: 20 absolute: false
                        radiusX: 30 radiusY: 20
                        largeArcFlag: true sweepFlag: true
                    }
                ]
            }
            
            Text { x: 60 y: 130 content: "1" font: font}
            Text { x: 170 y: 130 content: "2" font: font}
            Text { x: 60 y: 230 content: "3" font: font}
            Text { x: 120 y: 230 content: "4" font: font}
        ]
    }
}
