package javafxshapes;

import javafx.scene.Scene;
import javafx.scene.shape.LineTo;
import javafx.scene.shape.MoveTo;
import javafx.scene.shape.Path;
import javafx.scene.shape.StrokeLineJoin;
import javafx.stage.Stage;

Stage {
    title: "Path Element Joins"
    scene: Scene {
        width: 200
        height: 200
        content: [
            // Default miter join.
            Path {
                strokeWidth: 10
                strokeLineJoin: StrokeLineJoin.MITER
                elements: [
                    MoveTo { x: 20 y: 50 }
                    LineTo { x: 0 y: -30 absolute: false}
                    LineTo { x: 100 y: 20 absolute: false }
                ]
            }

            // Bevel join
            Path {
                strokeWidth: 10
                strokeLineJoin: StrokeLineJoin.BEVEL
                elements: [
                    MoveTo { x: 20 y: 110 }
                    LineTo { x: 0 y: -30 absolute: false}
                    LineTo { x: 100 y: 20 absolute: false }
                ]
            }

            // Round join
            Path {
                strokeWidth: 10
                strokeLineJoin: StrokeLineJoin.ROUND
                elements: [
                    MoveTo { x: 20 y: 170 }
                    LineTo { x: 0 y: -30 absolute: false}
                    LineTo { x: 100 y: 20 absolute: false }
                ]
            }
        ]
    }
}