package javafxshapes;

import javafx.scene.CustomNode;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Line;

public class Wheel extends CustomNode {
    public var fill: Color = Color.WHITE;
    public var stroke: Color = Color.BLACK;
    public var radius: Number = 20;

    override var children =
            Group {
                content: [
                    Circle {
                        centerX: bind radius centerY: bind radius
                        radius: bind radius
                        fill: bind fill stroke: bind stroke
                        strokeWidth: 2
                    }
                    Line {
                        startX: bind radius startY: 0
                        endX: bind radius   endY: bind 2 * radius
                        stroke: bind stroke
                        strokeWidth: 2
                    }
                    Line {
                        startX: 0 startY: bind radius
                        endX: bind 2 * radius endY: bind radius
                        stroke: bind stroke
                        strokeWidth: 2
                    }
                ]
            }
}


