package javafxtransforms;

import javafx.scene.paint.Color;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

var scene:Scene;
var node:Node;
Stage {
    title: "Bounds #8"
    scene: scene = Scene {
            width: 200
            height: 200
            content: [
                CoordinateGrid {
                    width: bind scene.width
                    height: bind scene.height
                }
                CoordinateGrid {
                    width: bind scene.width
                    height: bind scene.height
                    gridLineColor: Color.BLACK
                    translateX: 30
                    translateY: 60
                }
                node = Rectangle {
                    width: 100
                    height: 40
                    fill: Color.YELLOW
                    translateX: 30
                    translateY: 60
                    onMouseMoved: function(evt) {
                        println("Mouse at ({evt.x}, {evt.y})")
                    }
                }
            ]
        }
}
println("Layout bounds: {node.layoutBounds}");
println("Local bounds: {node.boundsInLocal}");
println("Parent bounds: {node.boundsInParent}");