package javafxtransforms;

import javafx.animation.Interpolator;
import javafx.animation.Timeline;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.scene.transform.Scale;
import javafx.stage.Stage;

bound function centerX(src:Node, target:Node):Number {
    var srcX = src.boundsInParent.minX;
    var srcWidth = src.boundsInParent.width;
    var targetX = target.layoutBounds.minX;
    var targetWidth = target.layoutBounds.width;
    return srcX + (srcWidth - targetWidth) / 2 - targetX;
}

bound function centerY(src:Node, target:Node):Number {
    var srcY = src.boundsInParent.minY;
    var srcHeight = src.boundsInParent.height;
    var targetY = target.layoutBounds.minY;
    var targetHeight = target.layoutBounds.height;
    return srcY + (srcHeight - targetHeight) / 2 - targetY;
}

var scaleX = 1.0;
var scaleY = 1.0;
var angle = 0;
var timeline:Timeline;
Stage {
    title: "Center Node"
    scene: Scene {
        width: 340
        height: 200
        var rect:Rectangle;
        var text:Text;
        content: [
            rect = Rectangle {
                x: 50 y: 40 width: 120 height: 50
                fill: Color.YELLOW
                transforms: bind Scale {
                    x: scaleX y: scaleY
                    pivotX: 50 pivotY: 50
                }
                onMousePressed: function(evt) {
                    timeline.play();
                }
            },
            text = Text {
                content: "Centered"
                font: Font { size: 24 }
                layoutX: bind centerX(rect, text);
                layoutY: bind centerY(rect, text);
                rotate: bind angle
            }
        ]
    }
}

timeline = Timeline {
    repeatCount: Timeline.INDEFINITE
    autoReverse: true
    keyFrames: [
        at (0s) {
            scaleX => 1.0 tween Interpolator.LINEAR;
            scaleY => 1.0 tween Interpolator.LINEAR;
            angle => 0 tween Interpolator.LINEAR;
        }
        at (5s) {
            scaleX => 2.0 tween Interpolator.LINEAR;
            scaleY => 2.0 tween Interpolator.LINEAR;
            angle => 360 tween Interpolator.LINEAR;
        }
    ]
}
