package javafxtransforms;

import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;

var image:Image = Image {
    url: "{__DIR__}images/portsmouthSmall.jpg"
};
var imageView:ImageView;
Stage {
    title: "Clip #1"
    scene: Scene {
        width: image.width
        height: image.height
        content: [
            Rectangle {
                width: bind image.width
                height: bind image.height
                fill: Color.BLACK
            }
            imageView = ImageView {
                var centerX = image.width / 2
                var centerY = image.height / 2
                image: image
                clip: bind Circle {
                               centerX: centerX
                               centerY: centerY
                               radius: 100
                           }
                onMouseDragged: function(evt) {
                    centerX = evt.x;
                    centerY = evt.y;
                }
            }
        ]
    }
}