package javafxtransforms;

import javafx.scene.CustomNode;
import javafx.scene.paint.Color;
import javafx.scene.shape.Line;
import javafx.scene.Node;

public class CoordinateGrid extends CustomNode {
    public var gridLineColor:Color = Color.LIGHTGRAY;
    public var gridDistance = 10;
    public var width:Number;
    public var height:Number;

    protected override var children = bind [
        createHorizontalLines(),
        createVerticalLines()
// We should be able to inline this, but we can't because of a bug in
// JavaFX 1.3. Filed issue http://javafx-jira.kenai.com/browse/JFXC-4401.
//        for (column in [0..width / gridDistance]) {
//            Line {
//                startX: column * gridDistance
//                startY: 0
//                endX: column * gridDistance
//                endY: height - 1
//                stroke: gridLineColor
//                fill: gridLineColor
//            }
//        }
//        for (row in [0..height / gridDistance]) {
//            Line {
//                startX: 0
//                startY: row * gridDistance
//                endX: width - 1
//                endY: row * gridDistance
//                stroke: gridLineColor
//            }
//        }
    ];

    bound function createVerticalLines() : Node[] {
        for (column in [0..width / gridDistance]) {
            Line {
                startX: column * gridDistance
                startY: 0
                endX: column * gridDistance
                endY: height - 1
                stroke: gridLineColor
                fill: gridLineColor
            }
        }
    }

    bound function createHorizontalLines() : Node[] {
        for (row in [0..height / gridDistance]) {
            Line {
                startX: 0
                startY: row * gridDistance
                endX: width - 1
                endY: row * gridDistance
                stroke: gridLineColor
            }
        }
    }

}
