package javafxbasics;

import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.scene.Scene;
import javafx.scene.text.Text;
import javafx.stage.Stage;

// Defines the counter and an animation of that counter that 
// increments its value once per second.
var counter = 0;
var animation = Timeline {      
    repeatCount: 10
    keyFrames: [
        KeyFrame {
            time: 1s
            action: function() {
                    counter = counter + 1
            }
        }
    ]
};

// Displays the counter on the screen
Stage {
    title: "Animated Counter"
    visible: true
    resizable: false
    width: 250
    height: 100
    scene: Scene {
        content: [
            Text {
                content: bind "Counter value is {counter}"
                x: 70
                y: 40
            }
        ]
    }
}

// Starts the animation of the counter.
animation.play();           