
package javafxbasics;

import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.text.Text;
import javafx.stage.Stage;

/**
 * A JavaFX class that illustrates JavaFX documentation.
 * @author Kim Topley
 */
public class JavaFXDocExample {
    /**
     * The text that will be displayed in the scene.
     */
    var text:String;

    /**
     * Creates a Scene containing some text.
     * @see javafx.scene.Scene
     * @see javafx.scene.text.Text
     * @param color the color to be used for the text.
     * @return a scene displaying the given text.
     */
    public function createScene(color:Color):Scene {
        Scene {
            content: [
                Text {
                    x: 10
                    y: 20
                    content: text
                    fill: color
                }
            ]
        }
    }
}

function run() {
    // Show the Scene.
    var e = JavaFXDocExample {
                text: "JavaFX Documentation Example"
            };
    Stage {
        title: "JavaFX Documentation Example"
        visible: true
        scene: e.createScene(Color.RED);
    }
}

