package javafxbinding;

import javafx.animation.Interpolator;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.scene.Scene;
import javafx.stage.Stage;
import javafx.geometry.HPos;
import javafx.geometry.VPos;
import javafx.scene.control.Label;
import javafx.scene.control.TextBox;
import javafx.scene.layout.VBox;

var timeLeft:Integer;

var timeLine = Timeline {      
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            time: 0s
            values: timeLeft => 10        
        },
        KeyFrame {
            time: 10s
            values: timeLeft => 0 tween Interpolator.LINEAR     
        }      
    ]          
};
timeLine.play();

Stage {
    var scene:Scene;
    title: "Expression Binding #3"
    visible: true width: 250 height: 120
    scene: scene = Scene {
        content: [
            VBox {
                var textBox:TextBox;
                width: bind scene.width height: bind scene.height
                nodeHPos: HPos.CENTER vpos: VPos.CENTER
                content: [
                    textBox = TextBox {
                        text: "Please type here"
                        selectOnFocus: true
                    }
                    Label {
                        text: bind if (timeLeft == 1) "{timeLeft} second remaining"
                                   else "{timeLeft} seconds remaining"
                        vpos: VPos.CENTER
                    }
                ]
            }
        ]
    }
}




