package javafxbinding;

import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.util.Math;
import javafx.scene.control.Slider;

var radius = 10.0;
var font = Font.font("Arial", FontWeight.BOLD, 16);

function computeArea(radius:Integer):Integer {
    Math.round(Math.PI * radius * radius) as Integer
}

Stage {
    title: "Binding to a Function"
    visible: true
    width: 250
    height: 180
    resizable: false
    scene: Scene {
              fill: Color.WHITE
              content: [
                  Group {
                    content: [
                        Circle {
                            centerX: 60
                            centerY: 60
                            radius: bind radius
                            fill: Color.GREEN
                        },
                        Text {
                             content: bind "Radius: {radius}"
                             font: font
                             x: 120
                             y: 50
                         },
                         Text {
                             content: bind "Area: {computeArea(radius)}"
                             font: font
                             x: 120
                             y: 80
                         },
                    ]
                  },
                  Slider {
                      min: 1
                      max: 50
                      vertical: false
                      value: bind radius with inverse
                      translateX: 20
                      translateY: 120
                  }
              ]
           }
}