package javafxsequences;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import javafxsequences.NameSource;

var names = new ArrayList();
names.add("Armstrong");
names.add("Aldrin");
names.add("Collins");

// Iterate over a list of strings
for (name in names) {
    println(name);
}
println("----------------");

// Iterate over a subset of strings
for (name in names where (name as String).startsWith("A")) {
    println(name);
}
println("----------------");

// Iterate over a subset of a List<String>
var nameSource = new NameSource();
var javaNames = nameSource.getNames();
for (name in javaNames where name.startsWith("A")) {
    println(name);
}
println("----------------"); 

var map = new HashMap();
map.put("KeyA", "ValueA");
map.put("KeyB", "ValueB");
map.put("KeyC", "ValueC");

// Iterate over the keys of a Map
for (key in map.keySet()) {
    println("Key: {key}");
}
println("----------------");

// Iterate over the values in a Map
for (value in map.values()) {
    println("Value: {value}");
}
println("----------------");

// Iterate over the entries in a Map
for (e in map.entrySet()) {
    var entry = e as Map.Entry;
    println("Key: {entry.getKey()}, value {entry.getValue()}");
}
println("----------------");

