package javafxtriggers;

import java.lang.IllegalArgumentException;
import java.lang.System;
import java.util.Random;

class RandomNumbers {
    var random = new Random(System.currentTimeMillis());
    public var min:Number = 1 on replace oldValue {
                                  if (min < 1 or 
                                      (isInitialized(max) and min >= max)) {
                                      min = if (min >= 1) oldValue
                                            else 1;            
                                      throw new IllegalArgumentException(
                                               "Invalid min value: {oldValue}");
                                  }
                              };
    public var max:Number = 10 on replace oldValue {
                                  if (isInitialized(min) and max <= min) {
                                      max = if (min >= 10) oldValue
                                            else 10;
                                      throw new IllegalArgumentException(
                                               "Invalid max value: {oldValue}");
                                  }
                               };
    var range:Number = bind max - min;
    
    public function getRandom():Number {
        min + range * random.nextFloat();
    }
}

// Valid bounds
var r1 = RandomNumbers { min: 5 max: 20 };
println("Random number between {r1.min} and {r1.max}: {r1.getRandom()}");

// Invalid bounds
var r2 = RandomNumbers { min: -1 max: 20 };
println("Random number between {r2.min} and {r2.max}: {r2.getRandom()}");
