package javafxanimation;

import javafx.animation.Interpolator;
import javafx.animation.Timeline;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

var circle1:Circle;
var circle2:Circle;
Stage {
    title: "Animation #5"
    scene: Scene {
        width: 200
        height: 100
        content: [ 
            circle1 = Circle {
                centerX: 50
                centerY: 50
                radius: 40
            }
            circle2 = Circle {
                centerX: 150
                centerY: 50
                radius: 40
            }
        ]
    }
}

var timeline = Timeline {
    keyFrames: [
        at (0s) {
            circle1.fill => Color.color(1.0, 1.0, 0.0, 0);
            circle2.fill => Color.color(1.0, 1.0, 0.0);
            circle2.opacity => 0;
        }
        at (5s) {
            circle1.fill => Color.RED tween Interpolator.EASEBOTH;
            circle2.opacity => 1.0 tween Interpolator.EASEBOTH;
        }
    ]
}
timeline.play();