package javafxanimation;

import javafx.animation.Timeline;
import javafx.animation.transition.AnimationPath;
import javafx.animation.transition.OrientationType;
import javafx.animation.transition.PathTransition;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.scene.shape.ClosePath;
import javafx.scene.shape.CubicCurveTo;
import javafx.scene.shape.HLineTo;
import javafx.scene.shape.MoveTo;
import javafx.scene.shape.Path;
import javafx.scene.shape.VLineTo;
import javafx.stage.Stage;
import javafxanimation.Wheel;

var wheel = Wheel {
    radius: 20 fill: Color.YELLOW stroke: Color.BLACK
};

var path = Path {
    elements: [
        MoveTo { x: 10 y: 100 }
        CubicCurveTo {
            x: 190 y: 10
            controlX1: 50 controlY1: 10
            controlX2: 150 controlY2: 200
        }
        VLineTo { y: 190}
        HLineTo { x: 10 }
        ClosePath { }
    ]
    strokeWidth: 2 strokeDashArray: [8, 9]
    stroke: Color.BLUE
};

Stage {
    title: "Transitions #6"
    scene: Scene {
        width: 200 height: 200
        content: [
            wheel, path
        ]
    }
}


var transition = PathTransition {
    duration: 5s
    node: wheel
    repeatCount: Timeline.INDEFINITE
    autoReverse: true
    orientation: OrientationType.ORTHOGONAL_TO_TANGENT
    path: AnimationPath.createFromPath(path)
};
transition.play();

