package javafxanimation;

import javafx.animation.transition.ParallelTransition;
import javafx.animation.transition.PauseTransition;
import javafx.animation.transition.RotateTransition;
import javafx.animation.transition.SequentialTransition;
import javafx.animation.transition.TranslateTransition;
import javafx.scene.paint.Color;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.Scene;
import javafx.stage.Stage;
import javafxanimation.Wheel;

var wheel: Wheel;
var scene: Scene;
Stage {
    title: "Transitions #7"
    resizable: false
    scene:
    scene = Scene {
        width: 200
        height: 300
        fill: LinearGradient {
            startX: 0 startY: 0
            endX: 1.0 endY: 1.0
            stops: [
                Stop { offset: 0.0 color: Color.WHITE }
                Stop { offset: 0.5 color: Color.LIGHTGREY }
                Stop { offset: 1.0 color: Color.BLACK }
            ]
        }
        content: [
            wheel = Wheel {
                fill: Color.YELLOW stroke: Color.BLACK
                radius: 20
            }
        ]
    }
}

var transition = SequentialTransition {
    node: wheel
    content: [
        TranslateTransition {
            duration: 2s
            toX: (scene.width - wheel.layoutBounds.width)/ 2
            toY: 0
        }
        PauseTransition {
            duration: 0.5s
        }
        ParallelTransition {
            content: [
                TranslateTransition {
                    duration: 5s repeatCount: 10
                    autoReverse: true
                    byX: 0
                    toY: scene.height - wheel.layoutBounds.height
                }
                RotateTransition {
                    duration: 10s repeatCount: 5
                    toAngle: 360
                }
            ]
        }
    ]
}
transition.play();
