package javafxcharts;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.chart.part.NumberAxis;
import javafx.scene.chart.AreaChart;

var lineSeries1 = AreaChart.Series {
    name: "Line 1"
    data: for (x in [-50..50 step 10]) {
        AreaChart.Data { xValue: x yValue: 2 * x }
    }
};
var lineSeries2 = AreaChart.Series {
    name: "Line 2"
    data: for (x in [-50..50 step 10]) {
        AreaChart.Data { xValue: x yValue: 30 }
    }
};

Stage {
    title: "Area Chart #1"
    scene: Scene {
        content: [
            AreaChart {
                data: [ lineSeries1, lineSeries2 ]
                xAxis: NumberAxis {
                    upperBound: 50
                    lowerBound: -50
                    tickUnit: 10
                }
                yAxis: NumberAxis {
                   upperBound: 100
                   lowerBound: -100
                   tickUnit: 10
                }
            }
        ]
    }
}
