package javafxcharts;

import javafx.scene.Scene;
import javafx.scene.chart.BarChart;
import javafx.stage.Stage;
import javafx.scene.chart.part.CategoryAxis;
import javafx.scene.chart.part.NumberAxis;


var categories = [ "Duration", "EVA Time", "Samples (kg)" ];
var seriesData = [
    BarChart.Series {
        name: "Apollo 11"
        data: [
            BarChart.Data { category: "Duration" value: 195.5 }
            BarChart.Data { category: "EVA Time" value: 2.5 }
            BarChart.Data { category: "Samples (kg)" value: 22 }
        ]
    }
    BarChart.Series {
        name: "Apollo 15"
        data: [
            BarChart.Data { category: "Duration" value: 295.2 }
            BarChart.Data { category: "EVA Time" value: 19.2 }
            BarChart.Data { category: "Samples (kg)" value: 76.8 }
        ]
    }
    BarChart.Series {
        name: "Apollo 16"
        data: [
            BarChart.Data { category: "Duration" value: 265.9 }
            BarChart.Data { category: "EVA Time" value: 20.3 }
            BarChart.Data { category: "Samples (kg)" value: 94.7 }
        ]
    }
    BarChart.Series {
        name: "Apollo 17"
        data: [
            BarChart.Data { category: "Duration" value: 301.8 }
            BarChart.Data { category: "EVA Time" value: 22.1 }
            BarChart.Data { category: "Samples (kg)" value: 110.5 }
        ]
    }
];

Stage {
    title: "Bar Chart #1"
    scene: Scene {
        content: [
            BarChart {
                title: "Apollo Lunar Landings"
                data: seriesData
                categoryAxis: CategoryAxis {
                    categories: categories
                }
                valueAxis: NumberAxis {
                    upperBound: 310
                    tickUnit: 100
                }
            }
        ]
    }
}
