package javafxcharts;

import javafx.scene.Scene;
import javafx.scene.chart.BarChart;
import javafx.stage.Stage;
import javafx.scene.chart.part.CategoryAxis;
import javafx.scene.chart.part.NumberAxis;
import javafx.scene.paint.Color;

import javafx.scene.paint.Paint;

import javafx.scene.paint.LinearGradient;

import javafx.scene.paint.Stop;

var categories = [ "Duration", "EVA Time", "Samples (kg)" ];
var seriesData = [
    BarChart.Series {
        name: "Apollo 11"
        fill: Color.CHOCOLATE
        stroke: Color.BLACK
        data: [
            BarChart.Data { category: "Duration" value: 195.5 }
            BarChart.Data { category: "EVA Time" value: 2.5 }
            BarChart.Data { category: "Samples (kg)" value: 22


            fill: LinearGradient {
                    startX: 0 endX: 1 startY: 0 endY: 0
                    stops: [ Stop { offset: 0 color: Color.RED }
                    Stop { offset: 1.0 color: Color.ORANGE} ]} }
        ]
    }
    BarChart.Series {
        name: "Apollo 15"
        data: [
            BarChart.Data { category: "Duration" value: 295.2 }
            BarChart.Data { category: "EVA Time" value: 19.2 }
            BarChart.Data { category: "Samples (kg)" value: 76.8 }
        ]
    }
    BarChart.Series {
        name: "Apollo 16"
        data: [
            BarChart.Data { category: "Duration" value: 265.9 }
            BarChart.Data { category: "EVA Time" value: 20.3 }
            BarChart.Data { category: "Samples (kg)" value: 94.7 }
        ]
    }
    BarChart.Series {
        name: "Apollo 17"
        data: [
            BarChart.Data { category: "Duration" value: 301.8 }
            BarChart.Data { category: "EVA Time" value: 22.1 }
            BarChart.Data { category: "Samples (kg)" value: 110.5 }
        ]
    }
];

Stage {
    title: "Bar Chart #4"
    scene: Scene {
        content: [
            BarChart {
                title: "Apollo Lunar Landings"
                data: seriesData
                gradientCreator: gradientCreator
                categoryAxis: CategoryAxis {
                    categories: categories
                }
                valueAxis: NumberAxis {
                    upperBound: 310
                    tickUnit: 100
                }
            }
        ]
    }
}

function gradientCreator(series:BarChart.Series,
                         index:Integer, data:BarChart.Data, paint:Paint):Paint {
    if (paint instanceof Color) {
        var startColor = paint as Color;
        var endColor = startColor.color(startColor.red * 0.4,
                                        startColor.green * 0.4,
                                        startColor.blue * 0.4,
                                        startColor.opacity);
        return LinearGradient {
            startX: 0 endX: 1.0 startY: 0.0 endY: 0.0
            stops: [
                Stop { offset: 0.0 color: startColor }
                Stop { offset: 1.0 color: endColor }
            ]
        }
    }
    return paint;
}
