package javafxcharts;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.chart.part.NumberAxis;
import javafx.util.Math;
import javafx.scene.chart.BubbleChart;

var series1 = BubbleChart.Series {
    name: "Series 1"
    data: for (x in [1..20]) {
        BubbleChart.Data { xValue: 20 + 20 * (Math.random() - 0.5)
                           yValue: 20 + 20 * (Math.random() - 0.5)
                           radius: 1 + 5 * Math.random() }
    }
};
var series2 = BubbleChart.Series {
    name: "Series 2"
    data: for (x in [1..20]) {
        BubbleChart.Data { xValue: 40 + 20 * (Math.random() - 0.5)
                           yValue: 40 + 20 * (Math.random() - 0.5)
                           radius: 1 + 5 * Math.random() }
    }
};

Stage {
    title: "Bubble Chart #1"
    scene: Scene {
        content: [
            BubbleChart {
                data: [ series1, series2 ]
                xAxis: NumberAxis {
                    upperBound: 60
                    tickUnit: 10
                }
                yAxis: NumberAxis {
                   upperBound: 60
                   tickUnit: 10
                }
            }
        ]
    }
}
