package javafxcharts;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.chart.ScatterChart;
import javafx.util.Math;
import javafx.scene.image.Image;
import javafx.scene.chart.part.NumberAxis;
import javafx.scene.image.ImageView;

var series1 = ScatterChart.Series {
    name: "Series 1"
    data: for (x in [1..20]) {
        ScatterChart.Data { xValue: 20 + 10 * (Math.random() - 0.5)
                            yValue: 20 + 10 * (Math.random() - 0.5) }
    }
};
var series2 = ScatterChart.Series {
    name: "Series 2"
    data: for (x in [1..20]) {
        ScatterChart.Data { xValue: 40 + 10 * (Math.random() - 0.5)
                            yValue: 40 + 10 * (Math.random() - 0.5) }
    }
};

var chart:ScatterChart;
var image:Image;
Stage {
    title: "Customized Chart #2"
    scene: Scene {
        content: [
            chart = ScatterChart {
                data: [ series1, series2 ]
                xAxis: NumberAxis {
                    upperBound: 60
                    tickUnit: 10
                }
                yAxis: NumberAxis {
                   upperBound: 60
                   tickUnit: 10
                }
                customBackgroundContent: ImageView {
                    image: image = Image {
                        url: "https://duke.dev.java.net/images/rover/OnBridge11small.jpg"
                        preserveRatio: true
                    }
                    opacity: 0.5
                    layoutX: bind (chart.width - image.width)/2
                    layoutY: bind (chart.height - image.height)/2
                }
            }
        ]
    }
}
