package javafxcharts;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.chart.part.NumberAxis;
import javafx.scene.chart.ScatterChart;
import javafx.util.Math;

import javafx.scene.chart.part.Side;

import javafx.scene.paint.Color;

var series1 = ScatterChart.Series {
    name: "Series 1"
    data: for (x in [1..20]) {
        ScatterChart.Data { xValue: 20 + 10 * (Math.random() - 0.5)
                            yValue: 20 + 10 * (Math.random() - 0.5) }
    }
};
var series2 = ScatterChart.Series {
    name: "Series 2"
    data: for (x in [1..20]) {
        ScatterChart.Data { xValue: 40 + 10 * (Math.random() - 0.5)
                            yValue: 40 + 10 * (Math.random() - 0.5) }
    }
};

Stage {
    title: "Customized Chart #3"
    scene: Scene {
        content: [
            ScatterChart {
                data: [ series1, series2 ]
                xAxis: NumberAxis {
                    side: Side.TOP
                    axisStroke: Color.GREEN
                    axisStrokeWidth: 2
                    label: "x"
                    upperBound: 60
                    tickUnit: 10
                }
                yAxis: NumberAxis {
                   side: Side.RIGHT
                   axisStroke: Color.RED
                   axisStrokeWidth: 2
                   label: "y"
                   labelFill: Color.RED
                   upperBound: 60
                   tickUnit: 10
                }
            }
        ]
    }
}
