package javafxcharts;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.chart.LineChart;
import javafx.scene.chart.part.NumberAxis;

var lineSeries1 = LineChart.Series {
    name: "Line 1"
    data: for (x in [-50..50 step 10]) {
        LineChart.Data { xValue: x yValue: 2 * x }
    }
};
var lineSeries2 = LineChart.Series {
    name: "Line 2"
    data: for (x in [-50..50 step 10]) {
        LineChart.Data { xValue: x yValue: 30 }
    }
};

Stage {
    title: "Line Chart #1"
    scene: Scene {
        content: [
            LineChart {
                data: [ lineSeries1, lineSeries2 ]
                //showSymbols: false
                xAxis: NumberAxis {
                    upperBound: 50
                    lowerBound: -50
                    tickUnit: 10
                }
                yAxis: NumberAxis {
                   upperBound: 100
                   lowerBound: -100
                   tickUnit: 10
                }
            }
        ]
    }
}

