package javafxcharts;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.chart.LineChart;
import javafx.scene.chart.part.NumberAxis;


import javafx.scene.Node;
import javafx.scene.paint.Paint;

import javafx.scene.chart.part.PlotSymbol;

import javafx.scene.paint.Color;

var lineSeries1 = LineChart.Series {
    name: "Line 1"
    data: for (x in [-50..50 step 5]) {
        LineChart.Data { xValue: x yValue: 2 * x }
    }
};
var lineSeries2 = LineChart.Series {
    name: "Line 2"
    fill: Color.BLUE
    data: for (x in [-50..50 step 5]) {
        LineChart.Data { xValue: x yValue: 30 }
    }
    symbolCreator: seriesSymbolCreator
};

Stage {
    title: "Line Chart #2"
    scene: Scene {
        content: [
            LineChart {
                data: [ lineSeries1, lineSeries2 ]
                showSymbols: true
                symbolCreator: chartSymbolCreator
                xAxis: NumberAxis {
                    upperBound: 50
                    lowerBound: -50
                    tickUnit: 10
                }
                yAxis: NumberAxis {
                   upperBound: 100
                   lowerBound: -100
                   tickUnit: 10
                }
            }
        ]
    }
}

function seriesSymbolCreator(series:LineChart.Series,
                             seriesIndex:Integer,
                             data:LineChart.Data,
                             dataIndex:Integer,
                             paint:Paint):Node {
    var node = PlotSymbol.HollowDiamond {
        size: 12
        fill: paint
    }
}

function chartSymbolCreator(series:LineChart.Series,
                            seriesIndex:Integer,
                            data:LineChart.Data,
                            dataIndex:Integer,
                            paint:Paint):Node {
    PlotSymbol.HollowTriangle {
        size: 12
        fill: paint
    }
}

