package javafxcharts;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.chart.PieChart;
import javafx.scene.paint.Color;


var data = [
    PieChart.Data { label: "Apollo 11" value: 22 }
    PieChart.Data { label: "Apollo 12" value: 34.4 }
    PieChart.Data { label: "Apollo 13" value: 0 }
    PieChart.Data { label: "Apollo 14" value: 43.0 }
    PieChart.Data { label: "Apollo 15" value: 76.8 
                    fill: Color.CHOCOLATE }
    PieChart.Data { label: "Apollo 16" value: 94.7 }
    PieChart.Data { label: "Apollo 17" value: 110.5 }
];

Stage {
    title: "Pie Chart #3"
    var scene:Scene;
    scene: scene = Scene {
        width: 500
        height: 400
        content: [
            PieChart {
                width: bind scene.width
                height: bind scene.height
                title: "Weight of Lunar Samples by Flight (kg)"
                data: data
                pieToLabelLineCurved: true
                startAngle: 90
                clockwise: false
                pieStroke: Color.BLACK
                pieValueLabelFormater: function(value:Number,
                                                percent:Number):String {
                    "{value} kg"
                }
            }
        ]
    }
}
