package javafxcontrols;

import javafx.scene.Scene;
import javafx.stage.Stage;
import javafx.scene.layout.HBox;
import javafx.scene.control.ToggleGroup;
import javafx.scene.control.RadioButton;
import javafx.scene.layout.VBox;
import javafx.scene.control.CheckBox;
import javafx.scene.image.Image;
import javafx.geometry.VPos;
import javafx.scene.image.ImageView;


def baseURL = "http://www.hq.nasa.gov/office/pao/History/alsj/";
def images = [
    "{baseURL}a15/ap15-KSC-71PC-605.jpg",
    "{baseURL}a15/AS15-87-11720.jpg",
    "{baseURL}a15/AS15-84-11324.jpg",
    "{baseURL}a15/AS15-88-12013.jpg",
    "{baseURL}a15/ap15-S71-42217.jpg",
];
var selectedImage:Integer = -1;
var smooth:Boolean = false;
def placeholder = Image {
    url: "http://spaceflight.nasa.gov/gallery/images/apollo/apollo15/lores/s71-30463.jpg"
    width: 300
    preserveRatio: true
    smooth: true
}

var scene:Scene;
var hbox:HBox;
Stage {
    title: "Buttons #2"
    resizable: false
    scene: scene = Scene {
        content: [
            hbox = HBox {
                var toggleGroup = ToggleGroup {};
                var thumbnail:Thumbnail;
                height: bind scene.height - 8
                width: bind scene.width - 8
                layoutX: 4
                layoutY: 4
                spacing: 8
                content: [
                    VBox {
                        spacing: 4
                        vpos: VPos.CENTER
                        height: bind hbox.height
                        content: [
                            for (i in [0..<sizeof images]) {
                                RadioButton {
                                    toggleGroup: toggleGroup
                                    text: "View picture {i + 1}"
                                    override var selected on replace {
                                        if (selected) {
                                            selectedImage = i;
                                        }
                                    }
                                }
                            }
                            CheckBox {
                                text: "Use smooth scaling"
                                selected: bind smooth with inverse
                            }
                        ]
                    }
                    thumbnail = Thumbnail {
                        thumbURL: bind images[selectedImage]
                        thumbWidth: 300
                        thumbHeight: 300
                        smooth: bind smooth
                        placeholder: placeholder
                        action: function():Void {                            
                            Stage {
                                title: "{thumbnail.thumbURL}"
                                resizable: false
                                scene: Scene {
                                    content: ImageView {
                                        image: Image {
                                            url: thumbnail.thumbURL
                                        }
                                    }
                                }
                            }
                        }
                    }
                ]
            }
        ]
    }
}


