package javafxcontrols;

import javafx.stage.Stage;
import javafx.scene.Scene;

import javafx.scene.layout.VBox;

import javafx.scene.layout.HBox;

import javafx.scene.control.Button;

import javafx.geometry.HPos;
import javafx.geometry.VPos;

import javafx.scene.control.CheckBox;

import javafx.scene.control.Hyperlink;

import javafx.scene.control.Label;

import javafx.scene.text.Font;

import javafx.scene.control.ListView;

import javafx.scene.layout.LayoutInfo;

import javafx.scene.control.ProgressBar;
import javafx.scene.control.ProgressIndicator;

import javafx.scene.control.RadioButton;

import javafx.scene.control.ScrollBar;

import javafx.scene.control.Slider;
import javafx.scene.control.TextBox;
import javafx.scene.control.ToggleButton;

var scene:Scene;
Stage {
    title : "Controls"
    scene: scene = Scene {
        width: 400
        height: 550
        content: [
            VBox {
                width: bind scene.width
                height: bind scene.height
                vpos: VPos.CENTER
                hpos: HPos.CENTER
                spacing: 16
                content: [
                    HBox {
                        spacing: 16
                        hpos: HPos.CENTER
                        vpos: VPos.CENTER
                        content: [
                            Button {
                                text: "OK"
                            }
                            Button {
                                text: "Cancel"
                                strong: true
                            }
                        ]
                    }
                    CheckBox {
                        text: "Show tooltips at startup"
                        selected: true
                    }
                    Hyperlink {
                        text: "http://javafx.com"
                    }
                    VBox {
                        spacing: 8
                        hpos: HPos.CENTER
                        vpos: VPos.CENTER
                        content: [
                            Label {
                                text: "Label - default font"
                            }
                            Label {
                                text: "Label - larger font"
                                font: Font { size: 18 }
                            }
                        ]
                    }
                    ListView {
                        items: for (i in [1..20]) {
                            "Item #{i}"
                        }
                        layoutInfo: LayoutInfo {
                            height: 80
                        }
                    }
                    ProgressBar {
                        progress: 0.4
                    }
                    ProgressIndicator {
                        progress: 0.4
                    }
                    RadioButton {
                        text: "Radio Button"
                        selected: true
                    }
                    ScrollBar {
                        min: 0 max: 100 value: 30
                    }
                    Slider {
                        min: 0 max: 100 value: 40
                    }
                    TextBox {
                        promptText: "Password"
                        columns: 24
                        editable: true
                    }
                    HBox {
                        spacing: 16
                        hpos: HPos.CENTER
                        vpos: VPos.CENTER
                        content: [
                            ToggleButton {
                                text: "ToggleButton (selected)"
                                selected: true
                            }
                            ToggleButton {
                                text: "ToggleButton (not selected)"
                            }
                        ]
                    }
                ]
            }
        ]
    }
}

