package javafxcontrols;

import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.ListView;
import javafx.scene.layout.VBox;
import javafx.geometry.HPos;
import javafx.scene.layout.Flow;
import javafx.scene.control.Label;
import javafx.scene.control.TextBox;

import javafx.scene.layout.LayoutInfo;
import javafx.geometry.Insets;
import javafx.scene.layout.Priority;

var elements = [
    "First", "Second", "Third"
];

var scene:Scene;
Stage {
    title : "ListView #2"
    scene: scene = Scene {
        width: 200
        content: [
            VBox {
                width: bind scene.width
                height: bind scene.height
                nodeHPos: HPos.CENTER
                padding: Insets { top: 4 left: 4 bottom: 4 right: 4 }
                spacing: 16
                content: [
                    ListView {
                        layoutInfo: LayoutInfo {
                            hgrow: Priority.NEVER
                            hfill: false
                        }
                        items: bind elements
                    }
                    Flow {
                        var textBox:TextBox;
                        hgap: 8
                        content: [
                            Label {
                                text: "New item: "
                            }
                            textBox = TextBox {
                                columns: 15
                                action: function() {
                                    insert textBox.text.trim() into elements;
                                    textBox.text = ""
                                }
                            }
                        ]
                    }
                ]
            }
        ]
    }
}


