package javafxcontrols;

import javafx.scene.Scene;
import javafx.stage.Stage;
import javafx.scene.layout.HBox;
import javafx.scene.image.Image;
import javafx.scene.control.ListView;
import javafx.scene.layout.LayoutInfo;
import javafx.geometry.VPos;
import javafx.scene.image.ImageView;

import javafx.scene.paint.Color;
import javafx.geometry.Insets;
import javafx.scene.control.ListCell;

class Photo {
    var title:String;
    var image:Image;
}

def placeholder = Image {
    url: "http://spaceflight.nasa.gov/gallery/images/apollo/"
         "apollo15/lores/s71-30463.jpg"
    width: 300
    preserveRatio: true
    smooth: true
}

def baseURL = "http://www.hq.nasa.gov/office/pao/History/alsj/";
def imageURLs = [
    "{baseURL}a15/ap15-KSC-71PC-605.jpg",
    "{baseURL}a15/AS15-87-11720.jpg",
    "{baseURL}a15/AS15-84-11324.jpg",
    "{baseURL}a15/AS15-88-12013.jpg",
    "{baseURL}a15/ap15-S71-42217.jpg",
];

def photos = for (url in imageURLs) {
    Photo {
        title: "Image #{indexof url + 1}"
        image: Image {
            url: url
            backgroundLoading: true
            placeholder: placeholder
        }
    }
}

var listView:ListView;
var selectedPhoto:Photo = bind listView.selectedItem as Photo;

var scene:Scene;
Stage {
    title: "ListView #5"
    scene: scene = Scene {
        width: 400
        height: 320
        fill: Color.BLACK
        content: [
            HBox {
                height: bind scene.height
                width: bind scene.width
                padding: Insets { top: 4 left: 4
                                  bottom: 4 right: 4 }
                spacing: 8
                nodeVPos: VPos.CENTER
                content: [
                    listView = ListView {
                        items: photos
                        cellFactory: function():ListCell {
                            var cell:ListCell;
                            cell = ListCell {
                                node: ImageView {
                                    fitWidth: 100
                                    preserveRatio: true
                                    image: bind (cell.item as Photo).image
                                }
                            }
                        }
                        layoutInfo: LayoutInfo {
                            vfill: true
                            width: 140
                        }
                    }
                    ImageView {
                        fitWidth: 300
                        fitHeight: 300
                        smooth: true
                        preserveRatio: true
                        image: bind if (selectedPhoto == null)
                                    then placeholder
                                    else selectedPhoto.image
                    }
                ]
            }
        ]
    }
}








