package javafxcontrols;

import javafx.scene.CustomNode;
import javafx.scene.Node;
import javafx.scene.control.ScrollBar;
import javafx.scene.layout.ClipView;
import javafx.util.Math;

public class Scroller extends CustomNode {
    public var width:Number;
    public var height:Number;
    public var node:Node;
    public var clickToPosition:Boolean;

    protected override var children = {
            var hsb:ScrollBar;
            var vsb:ScrollBar;
            var cv:ClipView;
            [
                cv = ClipView {
                    width: bind width - vsb.width
                    height: bind height - hsb.height
                    node: bind node
                    pannable: false
                }
                hsb = ScrollBar {
                    clickToPosition: bind clickToPosition
                    max: bind Math.max(0, node.layoutBounds.width - cv.width)
                    width: bind width - vsb.width
                    layoutY: bind height - hsb.height
                    blockIncrement: bind cv.layoutBounds.width - 4
                    override var value on replace {
                        cv.clipX = value;
                    }
                }
                vsb = ScrollBar {
                    clickToPosition: bind clickToPosition
                    vertical: true
                    max: bind Math.max(0, node.layoutBounds.height - cv.height)
                    height: bind height - hsb.height
                    layoutX: bind width - vsb.width
                    blockIncrement: bind cv.layoutBounds.height - 4
                    override var value on replace {
                        cv.clipY = value;
                    }
                }
            ];
        }
}

