package javafxcontrols;

import javafx.scene.CustomNode;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.control.Hyperlink;
import javafx.geometry.HPos;

public class Thumbnail extends CustomNode {
    public var thumbURL:String;
    public var thumbWidth:Number;
    public var thumbHeight:Number;
    public var action: function():Void;
    public var smooth:Boolean;
    public var placeholder:Image;
    
    protected override var children = {
            var link:Hyperlink;
            [
                ImageView {
                    fitWidth: bind thumbWidth
                    fitHeight: bind thumbHeight
                    preserveRatio: true
                    smooth: bind smooth
                    image: bind Image {
                        url: thumbURL
                        backgroundLoading: true
                        placeholder: placeholder
                    }
                }
                link = Hyperlink {
                    layoutX: bind (thumbWidth - link.layoutBounds.width) / 2
                    layoutY: bind thumbHeight + 2
                    text: "View at full size"
                    hpos: HPos.CENTER
                    disable: bind thumbURL == ""
                    action: bind action
                }
            ]
        }
}
