package javafxcustom;

import javafx.scene.CustomNode;
import javafx.scene.paint.Color;
import javafx.scene.shape.Line;
import javafx.scene.Node;

public class CoordinateGrid extends CustomNode {
    public var gridLineColor:Color = Color.LIGHTGRAY;
    public var gridDistance = 10;
    public var width:Number;
    public var height:Number;

    protected override var children = bind [
        createHorizontalLines(),
        createVerticalLines()
    ];

    bound function createVerticalLines() : Node[] {
        for (column in [0..width / gridDistance]) {
            Line {
                startX: column * gridDistance
                startY: 0
                endX: column * gridDistance
                endY: height - 1
                stroke: gridLineColor
                fill: gridLineColor
            }
        }
    }

    bound function createHorizontalLines() : Node[] {
        for (row in [0..height / gridDistance]) {
            Line {
                startX: 0
                startY: row * gridDistance
                endX: width - 1
                endY: row * gridDistance
                stroke: gridLineColor
            }
        }
    }
}
