/*
 * FXCenter.fx
 *
 * Created on 23-Jul-2009, 20:34:18
 */

package javafxcustom;

import javafx.scene.layout.Container;

import javafx.util.Math;

import javafx.geometry.HPos;
import javafx.geometry.VPos;

public class FXCenter extends Container {
    public override function getPrefWidth(height:Number) {
        var result = 0.0;
        for (node in getManaged(content)) {
            result = Math.max(result, getNodePrefWidth(node));
        }
        result;
    }

    public override function getPrefHeight(height:Number) {
        var result = 0.0;
        for (node in getManaged(content)) {
            result = Math.max(result, getNodePrefHeight(node));
        }
        result;
    }
    public override function getMinWidth() {
        var result = 0.0;
        for (node in getManaged(content)) {
            result = Math.max(result, getNodeMinWidth(node));
        }
        result;
    }

    public override function getMinHeight() {
        var result = 0.0;
        for (node in getManaged(content)) {
            result = Math.max(result, getNodeMinHeight(node));
        }
        result;
    }
    
    // Performs node layout on request.
    protected override function doLayout():Void {
        for (node in getManaged(content)) {
            positionNode(node, 0, 0, width, height,
                         HPos.CENTER, VPos.CENTER);
        }
    }
}
