package javafxcustom;

import javafx.scene.control.Control;
import javafx.scene.paint.Color;
import javafx.scene.media.MediaPlayer;

import javafx.scene.paint.Paint;

public class MediaPlayerBar extends Control {
    public var player:MediaPlayer;
    public var normalFill:Paint = Color.LIGHTGRAY;
    public var activeFill:Paint = Color.WHITE;

    public-read def playing = bind player.status == MediaPlayer.PLAYING;
    public-read def paused = bind player.paused;
    public-read def totalTime:Duration = bind player.media.duration;
    public-read def currentTime:Duration = bind player.currentTime;
    public-read def bufferedTime:Duration =
                                bind player.bufferProgressTime on replace {
        if (bufferedTime > currentTime and not paused) {
            player.play();
        }
    }
    public-read def fractionPlayed = bind if (totalTime == 0s) 0
                                          else currentTime.div(totalTime);
    public-read def fractionBuffered =
           bind if (totalTime == 0s) 0 else bufferedTime.div(totalTime);

    override var skin = MediaPlayerBarSkin {};

    public function play() {
        player.play();
    }

    public function pause() {
        player.pause();
    }

    public function stop() {
        player.stop();
    }

    public function setPlayPosition(position:Number) {
        player.currentTime = player.media.duration * position;
    }

    public function adjustPlayPosition(amount:Duration) {
        player.currentTime += amount;
    }
}

