package javafxcustom;

import javafx.scene.control.Behavior;
import javafx.scene.input.KeyEvent;
import javafx.scene.input.KeyCode;

package class MediaPlayerBarBehavior extends Behavior {
    def control = bind skin.control as MediaPlayerBar;
    
    package function playPressed() {
        control.play();
    }

    package function pausePressed() {
        control.pause();
    }

    package function stopPressed() {
        control.stop();
    }

    package function playPositionChanged(position:Number) {
        control.setPlayPosition(position);
    }

    package function mouseWheelMoved(amount:Number) {
        control.adjustPlayPosition(amount * 1s);
    }

    public override function callActionForEvent(e:KeyEvent) {
        if (e.code == KeyCode.VK_HOME) {
            control.setPlayPosition(0.0);
        } else if (e.code == KeyCode.VK_RIGHT) {
            control.adjustPlayPosition(1s);
        } else if (e.code == KeyCode.VK_LEFT) {
            control.adjustPlayPosition(-1s);
        }
    }
}
