package javafxcustom;

import javafx.scene.control.Control;
import javafx.scene.control.Skin;
import javafx.scene.control.Behavior;
import javafx.scene.text.Text;
import javafx.scene.text.TextOrigin;
import javafx.scene.layout.Container;
import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.input.MouseEvent;

public class MyControl extends Control {
    public var textFill:Color = Color.BLACK;
    public var font = Font.DEFAULT;
    public var text:String;
    override var skin = MySkin {};
}

public class MySkin extends Skin {
    var c = bind control as MyControl;
    override var behavior = MyBehavior {};
    override var node = Group {
            content: [
                Text {
                    content: bind c.text
                    fill: bind c.textFill;
                    font: bind c.font
                    textOrigin: TextOrigin.TOP
                }
            ]
            onMousePressed: function(evt) {
                (behavior as MyBehavior).mousePress(evt);
            }
        };

    override function getMinWidth():Number { 0 }

    override function getMinHeight():Number { 0 }

    override function getMaxWidth():Number { Number.MAX_VALUE }

    override function getMaxHeight():Number { Number.MAX_VALUE }

    override function getPrefWidth(height:Number):Number { 
        Container.getNodePrefWidth(node, height)
    }

    override function getPrefHeight(width:Number):Number { 
        Container.getNodePrefHeight(node, width)
    }

    override function contains(x:Number, y:Number) {
        node.contains(x, y);
    }
    override function intersects(x:Number, y:Number,
                                 width:Number, height:Number) {
        node.intersects(x, y, width, height);
    }
}

class MyBehavior extends Behavior {
    function mousePress(evt:MouseEvent) {
        println("Mouse press on control");
        skin.control.requestFocus();
    }

    override function callActionForEvent(evt) {
        println("Key event: {evt}");
    }
}


