package javafximport;

import javafx.animation.Interpolator;
import javafx.animation.transition.AnimationPath;
import javafx.animation.transition.FadeTransition;
import javafx.animation.transition.ParallelTransition;
import javafx.animation.transition.PathTransition;
import javafx.fxd.FXDLoader;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.shape.SVGPath;
import javafx.stage.Stage;

var url = "{__DIR__}Banner2.fxz";
var content = FXDLoader.loadContent(url);
var javafxTextNode = content.getNode("JavaFXTextNode");
javafxTextNode.transforms = null;
var javafxTextPath = content.getNode("TextPath") as SVGPath;
delete javafxTextPath from (javafxTextPath.parent as Group).content;
var transition = ParallelTransition {
    content: [
        PathTransition {
            node: javafxTextNode
            path: AnimationPath.createFromPath(javafxTextPath);
            interpolator: Interpolator.EASEOUT
            duration: 3s
        }
        FadeTransition {
            node: javafxTextNode
            fromValue: 0.0
            toValue: 1.0
            duration: 1s
        }
    ]
}

Stage {
    title: "Banner Example #4"
    scene: Scene {
        content: [
            content.getRoot()
        ]
    }
}
transition.play();
