package javafxmedia;

import javafx.animation.Interpolator;
import javafx.animation.transition.ScaleTransition;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;
import javafx.scene.paint.Color;
import javafx.scene.Scene;
import javafx.stage.Stage;

var mediaURL = "http://sun.edgeboss.net/download/sun/media/1460825906/"
               "1460825906_2956241001_big-buck-bunny-640x360.flv";

var mediaPlayer: MediaPlayer;
var mediaView: MediaView;
var done = false;
var currentTime = bind mediaPlayer.currentTime on replace {
    if (currentTime > 0s and not done) {
        done = true;
        var s = ScaleTransition {
            node: mediaView
            fromX: 0.5 fromY: 0.5
            toX: 1.0 toY: 1.0
            interpolator: Interpolator.LINEAR
            duration: 3s
        };
        s.play();
    }
}

Stage {
    title: "Media #11"
    resizable: false
    scene: Scene {
        width: 640
        height: 360
        fill: Color.BLACK
        content: [
            mediaView = MediaView {
                mediaPlayer:
                mediaPlayer = MediaPlayer {
                    autoPlay: true;
                    media: Media {
                        source: mediaURL
                    }
                }
            }
        ]
    }
}