package javafxmedia;

import javafx.geometry.Rectangle2D;
import javafx.scene.CustomNode;
import javafx.scene.Group;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafx.scene.shape.Rectangle;
import javafx.scene.layout.Resizable;

public class ScalingMediaView extends CustomNode, Resizable {
    public var fill: Paint = Color.TRANSPARENT;
    public var stretch: Boolean = false;
    public var mediaPlayer: MediaPlayer;
    public var viewport:Rectangle2D;

    var media: Media = bind if (mediaPlayer == null) null
                            else mediaPlayer.media;

    var mediaView: MediaView = MediaView {
        mediaPlayer: bind mediaPlayer
        layoutX: bind (width - mediaView.layoutBounds.width) / 2
        layoutY: bind (height - mediaView.layoutBounds.height) / 2
        fitWidth: bind if (stretch or media.width > width) width else 0
        fitHeight: bind if (stretch or media.height > height) height else 0;
        preserveRatio: true
        viewport: bind viewport
    }

    protected override function create():Node {
        return Group {
            content: [
                Rectangle {
                    x: 0 y: 0
                    width: bind width height: bind height
                    fill: bind fill
                }
                mediaView
            ]
        }
    }

    protected override function getPrefHeight(width:Number) {
        mediaView.layoutBounds.height
    }

    protected override function getPrefWidth(height:Number) {
        mediaView.layoutBounds.width
    }
}
